/**
 * NXKw
 *                  TJThread                     CWinThread
 *                                                   
 *                                                   
 *                                                   
 *                 TJMFCThread  <>====<>  TJWinThread  CWinApp
 *                                                   
 *                                                   
 *                                                   
 *       (WorkerThread) TJMFCGUIThread                (CXxxApp)
 *                          
 *                          
 *                          
 *                      (GUIThread)
 *
 *
 * thrdcore.cpp ̊֘AR[h
 *
 * UINT APIENTRY _AfxThreadEntry(void* pParam) {
 *     _AFX_THREAD_STARTUP* pStartup = (_AFX_THREAD_STARTUP*)pParam;
 *     CWinThread* pThread = pStartup->pThread;
 *     CWnd threadWnd;
 * 
 *     // inherit parent's module state
 *     _AFX_THREAD_STATE* pThreadState = AfxGetThreadState();
 *     pThreadState->m_pModuleState = pStartup->pThreadState->m_pModuleState;
 * 
 *     // set current thread pointer for AfxGetThread
 *     AFX_MODULE_STATE* pModuleState = AfxGetModuleState();
 *     AFX_MODULE_THREAD_STATE* pState = pModuleState->m_thread;
 *     pState->m_pCurrentWinThread = pThread;
 * 
 *     // forced initialization of the thread
 *     AfxInitThread();
 * 
 *     // thread inherits app's main window if not already set 
 *     CWinApp* pApp = AfxGetApp();
 *     if (pApp != NULL && pThread->m_pMainWnd == NULL &&
 *             pApp->m_pMainWnd->GetSafeHwnd() != NULL) {
 *         // just attach the HWND
 *         threadWnd.Attach(pApp->m_pMainWnd->m_hWnd);
 *         pThread->m_pMainWnd = &threadWnd;
 *     }
 * 
 *     // pStartup is invaid after the following SetEvent (but hEvent2 is valid)
 *     HANDLE hEvent2 = pStartup->hEvent2;
 * 
 *     // allow the creating thread to return from CWinThread::CreateThread
 *     VERIFY(::SetEvent(pStartup->hEvent));
 * 
 *     // wait for thread to be resumed
 *     VERIFY(::WaitForSingleObject(hEvent2, INFINITE) == WAIT_OBJECT_0);
 *     ::CloseHandle(hEvent2);
 * 
 *     // first -- check for simple worker thread
 *     DWORD nResult = 0;
 *     if (pThread->m_pfnThreadProc != NULL) {
 *         nResult = (*pThread->m_pfnThreadProc)(pThread->m_pThreadParams);
 *     }
 *     // else -- check for thread with message loop
 *     else if (!pThread->InitInstance()) {
 *         nResult = pThread->ExitInstance();
 *     }
 *     else {
 *         // will stop after PostQuitMessage called
 *         nResult = pThread->Run();
 *     }
 * 
 *     // cleanup and shutdown the thread
 *     threadWnd.Detach();
 *     AfxEndThread(nResult);
 * 
 *     return 0;   // not reached
 * }
 * 
 * // main running routine until thread exits
 * int CWinThread::Run() {
 *     // for tracking the idle time state
 *     BOOL bIdle = TRUE;
 *     LONG lIdleCount = 0;
 * 
 *     // acquire and dispatch messages until a WM_QUIT message is received.
 *     for ( ; ; ) {
 *         // phase1: check to see if we can do idle work
 *         while (bIdle && !::PeekMessage(&m_msgCur, 0, 0, 0, PM_NOREMOVE)) {
 *             // call OnIdle while in bIdle state
 *             if (!OnIdle(lIdleCount++))
 *                 bIdle = FALSE; // assume "no idle" state
 *         }
 * 
 *         // phase2: pump messages while available
 *         do {
 *             // pump message, but quit on WM_QUIT
 *             if (!PumpMessage())
 *                 return ExitInstance();
 * 
 *             // reset "no idle" state after pumping "normal" message
 *             if (IsIdleMessage(&m_msgCur)) {
 *                 bIdle = TRUE;
 *                 lIdleCount = 0;
 *             }
 *         } while (::PeekMessage(&m_msgCur, 0, 0, 0, PM_NOREMOVE));
 *     }
 * 
 *     ASSERT(FALSE);  // not reachable
 * }
 * 
 * BOOL CWinThread::PumpMessage() {
 *     if (!::GetMessage(&m_msgCur, NULL, NULL, NULL)) {
 *         return FALSE;
 *     }
 *     if (m_msgCur.message != WM_KICKIDLE &&
 *             !PreTranslateMessage(&m_msgCur)) {
 *         ::TranslateMessage(&m_msgCur);
 *         ::DispatchMessage(&m_msgCur);
 *     }
 *     return TRUE;
 * }
 */

#include "TJMFCGUIThread.h"
#include "TJWinThread.h"
#include "tjdebug.h"

TJMFCGUIThread* TJMFCGUIThread::primary = 0;

/**
 * RXgN^
 */
TJMFCGUIThread::TJMFCGUIThread(unsigned stacksize /*=DEFSTACKSIZE*/,
		LPSECURITY_ATTRIBUTES lpsec /*=0*/)
		: TJMFCThread(stacksize, lpsec) {
}

TJMFCGUIThread::TJMFCGUIThread(const char* name,
		unsigned stacksize /*=DEFSTACKSIZE*/,
		LPSECURITY_ATTRIBUTES lpsec /*=0*/)
		: TJMFCThread(name, stacksize, lpsec) {
}

TJMFCGUIThread::TJMFCGUIThread(TJRunnable* target,
		unsigned stacksize /*=DEFSTACKSIZE*/,
		LPSECURITY_ATTRIBUTES lpsec /*=0*/)
		: TJMFCThread(target, stacksize, lpsec) {
}

TJMFCGUIThread::TJMFCGUIThread(TJRunnable* target, const char* name,
		unsigned stacksize /*=DEFSTACKSIZE*/,
		LPSECURITY_ATTRIBUTES lpsec /*=0*/)
		: TJMFCThread(target, name, stacksize, lpsec) {
}

TJMFCGUIThread::~TJMFCGUIThread() {
}

/**
 * main XbhIuWFNg̃|C^擾.
 *
 * main Xbh̃IuWFNg TJMFCThread ̃IuWFNgɕύX.
 * TJThread ł main Xbh̃IuWFNgō쐬邽 main
 * XbhTuNXƂɂ͗OKvɂȂ.
 */
TJMFCGUIThread* TJMFCGUIThread::primaryThread(LPSECURITY_ATTRIBUTES lpsec) {

	if (primary == 0) {
		primary = new TJMFCGUIThread(NOTHREAD, lpsec);
		mem_assert(primary);
		TJThread::exchange(primary);
		/*
		 * ̃LXg͊댯.
		 *  main Xbhł̃|C^ĝ
		 * GetMainWnd(), SetMainWnd() ݂̂ł肢
		 * CWinThread ̃oł.
		 */
		primary->m_pWinThread = (TJWinThread*)AfxGetApp();
	}
	return primary;
}

CWinApp* TJMFCGUIThread::getApp() {
	return (CWinApp*)AfxGetApp();
}

/**
 * CWinThread ̃bZ[W[v
 *
 * CWinThread  Run()  virtual ł邽߃bZ[W[v̒ڂ̃Gg
 *  TJWinThread::Run() ɂȂ. TJWinThread::Run() ͂̃\bhĂяo
 * Ă邽 TJMFCThread ŃbZ[W[v㏑ł邱ƂɂȂ.
 * ̃\bh̃ftHg̓IWi CWinThread::Run() ł.
 *  GUIThread ł͂̂܂܎g邪, WorkerThread ł̓[U쐬
 * bZ[W[vȂ\bhɃI[oCh.
 *
 * [memo]
 *
 * @see CWinThread::CreateThread() ---- mfc/src/thrdcore.cpp
 *     m_hThread = (HANDLE)_beginthreadex(... &_AfxThreadEntry, ...);
 *
 * @see _AfxThreadEntry() ---- mfc/src/thrdcore.cpp
 *     if (pThread->m_pfnThreadProc != NULL) {
 *             nResult = (*pThread->m_pfnThreadProc)(pThread->m_pThreadParams);
 *     } else if (!pThread->InitInstance()) {
 *             nResult = pThread->ExitInstance();
 *     } else {
 *             // will stop after PostQuitMessage called
 *             nResult = pThread->Run();
 *     }
 *
 * @see TJMFCThread::create()
 *     m_pfnThreadProc = TJThreadbody
 */
void TJMFCGUIThread::run() {
	ASSERT(m_pWinThread);
	if (!InitInstance())
		(void)ExitInstance();
	else
		(void)m_pWinThread->originalRun();
}

/**
 * ̃Xbh̃CEBhEl.
 */
CWnd* TJMFCGUIThread::GetMainWnd() {
	ASSERT(m_pWinThread);
	return m_pWinThread->m_pMainWnd;
}

/**
 * ̃Xbh̃CEBhEݒ肷.
 */
void TJMFCGUIThread::SetMainWnd(CWnd* pWnd) {
	ASSERT(m_pWinThread);
	m_pWinThread->m_pMainWnd = pWnd;
}
