/**
 * NXKw
 *                  TJThread                     CWinThread
 *                                                   
 *                                                   
 *                                                   
 *                 TJMFCThread  <>====<>  TJWinThread  CWinApp
 *                                                   
 *                                                   
 *                                                   
 *       (WorkerThread) TJMFCGUIThread                (CXxxApp)
 *                          
 *                          
 *                          
 *                      (GUIThread)
 *
 *
 * thrdcore.cpp ̊֘AR[h
 *
 * UINT APIENTRY _AfxThreadEntry(void* pParam) {
 *     _AFX_THREAD_STARTUP* pStartup = (_AFX_THREAD_STARTUP*)pParam;
 *     CWinThread* pThread = pStartup->pThread;
 *     CWnd threadWnd;
 * 
 *     // inherit parent's module state
 *     _AFX_THREAD_STATE* pThreadState = AfxGetThreadState();
 *     pThreadState->m_pModuleState = pStartup->pThreadState->m_pModuleState;
 * 
 *     // set current thread pointer for AfxGetThread
 *     AFX_MODULE_STATE* pModuleState = AfxGetModuleState();
 *     AFX_MODULE_THREAD_STATE* pState = pModuleState->m_thread;
 *     pState->m_pCurrentWinThread = pThread;
 * 
 *     // forced initialization of the thread
 *     AfxInitThread();
 * 
 *     // thread inherits app's main window if not already set 
 *     CWinApp* pApp = AfxGetApp();
 *     if (pApp != NULL && pThread->m_pMainWnd == NULL &&
 *             pApp->m_pMainWnd->GetSafeHwnd() != NULL) {
 *         // just attach the HWND
 *         threadWnd.Attach(pApp->m_pMainWnd->m_hWnd);
 *         pThread->m_pMainWnd = &threadWnd;
 *     }
 * 
 *     // pStartup is invaid after the following SetEvent (but hEvent2 is valid)
 *     HANDLE hEvent2 = pStartup->hEvent2;
 * 
 *     // allow the creating thread to return from CWinThread::CreateThread
 *     VERIFY(::SetEvent(pStartup->hEvent));
 * 
 *     // wait for thread to be resumed
 *     VERIFY(::WaitForSingleObject(hEvent2, INFINITE) == WAIT_OBJECT_0);
 *     ::CloseHandle(hEvent2);
 * 
 *     // first -- check for simple worker thread
 *     DWORD nResult = 0;
 *     if (pThread->m_pfnThreadProc != NULL) {
 *         nResult = (*pThread->m_pfnThreadProc)(pThread->m_pThreadParams);
 *     }
 *     // else -- check for thread with message loop
 *     else if (!pThread->InitInstance()) {
 *         nResult = pThread->ExitInstance();
 *     }
 *     else {
 *         // will stop after PostQuitMessage called
 *         nResult = pThread->Run();
 *     }
 * 
 *     // cleanup and shutdown the thread
 *     threadWnd.Detach();
 *     AfxEndThread(nResult);
 * 
 *     return 0;   // not reached
 * }
 * 
 * // main running routine until thread exits
 * int CWinThread::Run() {
 *     // for tracking the idle time state
 *     BOOL bIdle = TRUE;
 *     LONG lIdleCount = 0;
 * 
 *     // acquire and dispatch messages until a WM_QUIT message is received.
 *     for ( ; ; ) {
 *         // phase1: check to see if we can do idle work
 *         while (bIdle && !::PeekMessage(&m_msgCur, 0, 0, 0, PM_NOREMOVE)) {
 *             // call OnIdle while in bIdle state
 *             if (!OnIdle(lIdleCount++))
 *                 bIdle = FALSE; // assume "no idle" state
 *         }
 * 
 *         // phase2: pump messages while available
 *         do {
 *             // pump message, but quit on WM_QUIT
 *             if (!PumpMessage())
 *                 return ExitInstance();
 * 
 *             // reset "no idle" state after pumping "normal" message
 *             if (IsIdleMessage(&m_msgCur)) {
 *                 bIdle = TRUE;
 *                 lIdleCount = 0;
 *             }
 *         } while (::PeekMessage(&m_msgCur, 0, 0, 0, PM_NOREMOVE));
 *     }
 * 
 *     ASSERT(FALSE);  // not reachable
 * }
 * 
 * BOOL CWinThread::PumpMessage() {
 *     if (!::GetMessage(&m_msgCur, NULL, NULL, NULL)) {
 *         return FALSE;
 *     }
 *     if (m_msgCur.message != WM_KICKIDLE &&
 *             !PreTranslateMessage(&m_msgCur)) {
 *         ::TranslateMessage(&m_msgCur);
 *         ::DispatchMessage(&m_msgCur);
 *     }
 *     return TRUE;
 * }
 *
 *   ̃NX̃XbhGg MFC ̃XbhGg̈ꕔƂ
 *       s. ă[JXbhł
 *             ProcessMessageFilter()
 *       ȂǂĂяoĂ܂.
 */

#include "TJMFCThread.h"
#include "TJPrimitive.h"
#include "tjdebug.h"

TJMFCThread* TJMFCThread::primary = 0;
const unsigned TJMFCThread::DEFSTACKSIZE = 0;

TJMFCThread::TJMFCThread(unsigned stacksize /*=DEFSTACKSIZE*/,
		LPSECURITY_ATTRIBUTES lpsec /*=0*/)
		: TJThread(NOTHREAD) {
	if (stacksize != NOTHREAD)
		createThread(stacksize, lpsec);
}

TJMFCThread::TJMFCThread(const char* name,
		unsigned stacksize /*=DEFSTACKSIZE*/,
		LPSECURITY_ATTRIBUTES lpsec /*=0*/)
		: TJThread(name, NOTHREAD) {
	if (stacksize != NOTHREAD)
		createThread(stacksize, lpsec);
}

TJMFCThread::TJMFCThread(TJRunnable* target,
		unsigned stacksize /*=DEFSTACKSIZE*/,
		LPSECURITY_ATTRIBUTES lpsec /*=0*/)
		: TJThread(target, NOTHREAD) {
	if (stacksize != NOTHREAD)
		createThread(stacksize, lpsec);
}

TJMFCThread::TJMFCThread(TJRunnable* target, const char* name,
		unsigned stacksize /*=DEFSTACKSIZE*/,
		LPSECURITY_ATTRIBUTES lpsec /*=0*/)
		: TJThread(target, name, NOTHREAD) {
	if (stacksize != NOTHREAD)
		createThread(stacksize, lpsec);
}

/**
 * fXgN^.
 */
TJMFCThread::~TJMFCThread() {
	if (m_pWinThread != 0) {
		delete m_pWinThread;
		m_pWinThread = 0;
	}
}

/**
 * main XbhIuWFNg̃|C^擾.
 *
 * main Xbh̃IuWFNg TJMFCThread ̃IuWFNgɕύX.
 * TJThread ł main Xbh̃IuWFNgō쐬邽 main
 * XbhTuNXƂɂ͗OKvɂȂ.
 */
TJMFCThread* TJMFCThread::primaryThread(LPSECURITY_ATTRIBUTES lpsec /*=0*/) {

	if (primary == 0) {
		primary = new TJMFCThread(NOTHREAD, lpsec);
		mem_assert(primary);
		TJThread::exchange(primary);
		primary->m_pWinThread = (TJWinThread*)AfxGetApp();
	}
	return primary;
}

/**
 * VXeˑ̃Xbh쐬.
 */
int TJMFCThread::create(void (*entrypoint)(void*), void* arg,
		unsigned stacksize, void* info, ID* ptid) {

	LPSECURITY_ATTRIBUTES lpsec = (LPSECURITY_ATTRIBUTES)info;

	m_pWinThread = new TJWinThread(this);
	mem_assert(m_pWinThread);

	m_pWinThread->m_pfnThreadProc = (AFX_THREADPROC)entrypoint;
	m_pWinThread->m_pThreadParams = arg;
	BOOL bStatus = m_pWinThread->CreateThread(CREATE_SUSPENDED,
			stacksize, lpsec);
	if (!bStatus)
		//TJSystem_Error("CreateThread() failed", ::GetLastError());
		return ::GetLastError();

	*ptid = (ID)m_pWinThread->m_nThreadID;

	void* array[2];
	array[0] = (void*)m_pWinThread->m_hThread;
	array[1] = isGUIThread()? (void*)1 : (void*)0;
	return ::TJThreadSetInfo((void*)m_pWinThread->m_nThreadID, array);
}

/**
 * WorkerThread ł͌ĂяoȂ.
 */
BOOL TJMFCThread::InitInstance() {
	/**
	 * TRUE ԂȂƏsƂ݂ȂđsłȂ.
	 */
	//return TRUE;
	ASSERT(m_pWinThread);
	return m_pWinThread->originalInitInstance();
}

/**
 * WorkerThread ł͌ĂяoȂ.
 */
int TJMFCThread::ExitInstance() {
	ASSERT(m_pWinThread);
	return m_pWinThread->originalExitInstance();
}

/**
 * WorkerThread ł͌ĂяoȂ.
 */
BOOL TJMFCThread::PreTranslateMessage(MSG* pMsg) {
	ASSERT(m_pWinThread);
	return m_pWinThread->originalPreTranslateMessage(pMsg);
}

/**
 * WorkerThread ł͌ĂяoȂ.
 */
BOOL TJMFCThread::OnIdle(LONG lCount) {
	ASSERT(m_pWinThread);
	return m_pWinThread->originalOnIdle(lCount);
}

/**
 * WorkerThread ł͌ĂяoȂ.
 */
BOOL TJMFCThread::IsIdleMessage(MSG* pMsg) {
	ASSERT(m_pWinThread);
	return m_pWinThread->originalIsIdleMessage(pMsg);
}

/**
 * WorkerThread ł͌ĂяoȂ.
 */
BOOL TJMFCThread::ProcessMessageFilter(int code, LPMSG lpMsg) {
	ASSERT(m_pWinThread);
	return m_pWinThread->originalProcessMessageFilter(code, lpMsg);
}

/**
 * WorkerThread ł͌ĂяoȂ.
 */
LRESULT TJMFCThread::ProcessWndProcException(CException* e, const MSG* pMsg) {
	ASSERT(m_pWinThread);
	return m_pWinThread->originalProcessWndProcException(e, pMsg);
}
