/*-----------------------------------------------------------------------

      Copyright (c) 1998,1999 Eiwa System Management, Inc

                      All Rights Reserved

  This file contains proprietary source code and other proprietary
  material owned by Eiwa System Management, Inc. Published only in
  limited copyright sence.

------------------------------------------------------------------------*/
/*
 * $Id: TJMonitor.h,v 1.16 1999/07/28 06:01:59 hiranabe Exp $
 */
#if !defined(TJMonitor_h)
#define TJMonitor_h


#ifndef tjconfig_h
#include "tjconfig.h"
#endif

#include <stddef.h>      // for size_t
#ifndef TJSyncObject_h
#include "TJSyncObject.h"
#endif

/**
 * j^Iy[Vx邽߂̃NX.
 *
 * j^Ƃ͓ɋLf[^, ̑상\bhKrIȃANZX
 * ƂȂ悤ɕۏ؂ꂽۃf[^^ł. ăj^Iy[VƂ
 * rIANZX̕ۏ؂ꂽ\bhӖ̂Ƃ.
 * Java  synchronized method  Object j^Ƃ郂j^Iy[V
 * ̗łD
 *
 * ̃NX͂ł邾SɃj^Iy[V邱ƂړIƂ
 * Ă. ܂Cjava  synchronized block L@}Nɂ񋟂D
 * RXgN^ƃfXgN^ɂăbN̎擾ƉĂ
 * ߁Cr return Oɂ return ɑ΂ĂbN̉
 * ۏ؂łD
 *
 *  TJMonitor  TJSyncObject g₷NXłI
 *  @\ TJSyncObject ɕĂ. TJSyncObject ̃hLg
 *  QƂ̂.
 *
 * {IȎgp@͈ȉ̒ʂD
 *
 * synchronized }Ngp
 *
 * \begin{verbatim}
 *  class Xxx : virtual public TJSyncObject {
 *    // ....
 *       void method() {
 *          // ...
 *          synchronized(this) { // ŃbN擾
 *              // rIȑ삪ۏ؂
 *          } // ŃbN
 *          // ...
 *
 *       }
 *  };
 * \end{verbatim}
 *
 * TJMonitor ̂܂܎gp(LƓӖ)
 *
 * \begin{verbatim}
 *  class Xxx : virtual public TJSyncObject {
 *    // ....
 *       void method() {
 *          // ...
 *          {  TJMonitor sync(this);  // ŃbN擾
 *             // rIȑ삪ۏ؂
 *          }  // ŃbN
 *          // ...
 *
 *       }
 *  };
 * \end{verbatim}
 * 
 * TJSyncObject  protected \bh𒼐ڎgp
 *
 * \begin{verbatim}
 *  class Xxx : virtual public TJSyncObject {
 *    // ....
 *       void method() {
 *          // ...
 *          lock(); // ŃbN擾
 *          // rIȑ삪ۏ؂
 *          unlock(); // ŃbN
 *          // ...
 *
 *       }
 *  };
 * \end{verbatim}
 *
 * ܂CTJSyncObject ł java ɂȂ@\ƂāCꎞIɃbNSɊO
 * @\D́Cunlock(),~JTMonitor(),  synchronized ubN
 * I肪CKbN̉ۏ؂łȂƂT|[gꂽ
 * @\łD̃\bh synchronized ubN̒Ă΂ꂽʂ
 * \bhɉẮCbN̎擾񂪃ReLXgˑƂȂ邱ƂɂȂ
 * łD
 *
 * ̋@\́Cȉ̂悤ɗpłD
 *
 * unsynchronized }Ngp
 *
 * \begin{verbatim}
 *  class Xxx : virtual public TJSyncObject {
 *    // ....
 *       void method() {
 *          synchronized(this) { // ł̓bN擾
 *              // rIȑ삪ۏ؂D
 *              unsynchronized(this) {  // ꎞIɃbN
 *                 // ̓bNOĂ邱Ƃۏ؂
 *              }
 *              // ĂуbN(Ȍ󋵂Ƃ͈Ⴄ\)
 *          }
 *
 *       }
 *  };
 * \end{verbatim}
 *
 * TJMonitor ̂܂܎gp(LƓӖ)
 *
 * \begin{verbatim}
 *  class Xxx : virtual public TJSyncObject {
 *    // ....
 *       void method() {
 *          { TJMonitor sync(this) // ŃbN擾
 *              // rIȑ삪ۏ؂D
 *              { TJMonitor unsync(this, TJMonitor::UNLOCK); // ꎞIɃbN
 *                 // ̓bNOĂ邱Ƃۏ؂
 *              }
 *              // ĂуbN(Ȍ󋵂Ƃ͈Ⴄ\)
 *          }
 *       }
 *  };
 * \end{verbatim}
 * 
 * TJSyncObject  protected \bh𒼐ڎgp
 *
 * \begin{verbatim}
 *  class Xxx : virtual public TJSyncObject {
 *    // ....
 *       void method() {
 *          lock();  // ł̓bN擾
 *          // rIȑ삪ۏ؂D
 *          int lock = unlockTemporarily(); // ꎞIɃbN
 *          // ̓bNOĂ邱Ƃۏ؂
 *          restoreLock(lock);
 *          // ... ĂуbN(Ȍ󋵂Ƃ͈Ⴄ\)
 *          unlock();
 *       }
 *  };
 * \end{verbatim}
 *
 * ̋@\́Cwait() ȊOɂbNSɉėv҂悤
 * dg݂񋟂邱ƁC܂CfbhbN̉̂߂̃bN̏
 * (Kw)_IɃT|[g邱ƂړIƂĂD(TJSyncObject Q)
 *
 * ̃NX̃IuWFNg쐬鎞ɂ̓[hwł.
 * ftHg LOCK [hł͒ʏ̔rbNl邪 UNLOCK [h
 * ͋tɊlĂ郍bN.
 *
 * 삪, ɋLq unsync @\łCj^̓ wait() ȊO
 * bNĉ炩̃Cxg҂킹ꍇȂǂɎgpD
 * Ƃ TJQueue O̓͑҂ȂǂY.
 *
 * ɑ΂ wait()͎IɃbN notify() 
 * ҂, Aɂ̓bN擾ԂŖ߂邽, bN̔ɎG
 * Ƃł. ̗Q.
 *
 * java  TJMonitor Ƃ̕\̈Ⴂ܂Ƃ߂Ǝ̂悤ɂȂ.
 *  synchronized }Ng synchronized block ͂܂
 * \\ synchronized method ͎cOȂ烁\bh{̂
 * synchronized block ̌`ɂ邵Ȃ.
 *
 * \begin{verbatim}
 *
 *          java                               TJMonitor
 *   -------------------------------------------------------------------
 *   synchronized void method() {       void method() {
 *         EEE                           TJMonitor monitor(syncptr);
 *   }                                        EEE
 *                                      }
 *                                           ܂
 *                                      void method() {
 *                                          synchronized(syncptr) {
 *                                              EEE
 *                                          }
 *                                      }
 *   - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
 *   synchronized(obj) {                {
 *         EEE                           TJMonitor syncblock(obj);
 *   }                                        EEE
 *                                      }
 *                                           ܂
 *                                      synchronized(obj) {
 *                                            EEE
 *                                      }
 *   -------------------------------------------------------------------
 * \end{verbatim}
 *
 * [fbhbNɊւʓIȒ]
 *
 * ̑쎩̂ł̓fbhbNNȂ.
 *
 * \begin{verbatim}
 *     j^Iy[V̍ċAďo
 *     j^Iy[V̒瓯IuWFNg̕ʂ̃j^Iy[
 *       Vďo
 * \end{verbatim}
 *
 *   ̑̓^C~OɂĂ̓fbhbNƂȂ.
 *
 * \begin{verbatim}
 *     IuWFNg A,B  A.m1(), B.m2() j^Iy[V
 *        A.m1()  B.m2() ďo B.m2()  A.m1() ďoꍇ
 * \end{verbatim}
 *
 *   ɕ̃bNKvȏꍇ̉ĂĂ.
 *   ƂΏL̃fbhbÑP[XȂ
 *       A,B  TJSyncObject ̃TuNXƂ.
 *       bNl鏇߂.
 *           A.lock();
 *           B.lock();
 *            EEE
 *           B.unlock();
 *           A.unlock();
 *
 * @author Susumu TOKUI
 * @date 1998,6/1
 * @see TJSyncObject
 */
class TJMonitor {

	friend class TJMonitorTester;

public:
	/**
	 * IuWFNg쐬ɃbNl邩邩.
	 *
	 * LOCK: bNl, UNLOCK: bN
	 */
	enum Mode { LOCK, UNLOCK };

private:
	/**
	 * bNIuWFNg
	 */
	TJSyncObject *const object;
	/**
	 * bNJE^
	 */
	int lockcount;

public:
	/**
	 * TJMonitor IuWFNg쐬.
	 *
	 * @param obj  bNpIuWFNg̃|C^
	 * @param mode LOCK: bNl, UNLOCK: bN
	 */
	explicit TJMonitor(const TJSyncObject* obj, Mode mode = LOCK);

	/**
	 * TJMonitor IuWFNg.
	 *
	 * LOCK[h̃IuWFNg̓bN, UNLOCK[h
	 * IuWFNg̓bN𕜌.
	 */
	virtual ~TJMonitor();

	/**
	 * synchronized }NT|[g邽߂̕ϊ.
	 *
	 * @return  false
	 */
	operator bool() const {
		return false;
	}

private:
	/*
	 * TJMonitor IuWFNg̑͋֎~.
	 */
	TJMonitor& operator=(const TJMonitor& obj);

	/*
	 * new Ăяo͋֎~.
	 * Monitor IuWFNgKX^bNɊmۂ.
	 */
	void* operator new(size_t);
};

/**
 * java synchronized ubNw肷}N.
 *
 *  gp@:
 *
 *  syncrhonized(obj) {
 *     // critical region
 *     // ....
 *  }
 *
 *  ̃}Nō쐬 Monitor IuWFNg̕ϐ,
 *  'msԍ' ƂȂ. Ⴆ΂̃}Ns 123 sڂƂ,
 *  m123 ̂悤ȖOł.
 *
 */
#define synchronized(obj) \
	if (TJMonitor m ## __LINE__  = TJMonitor(obj)) ; else

/**
 * bNꎞIɊO}N.
 *
 *  gp@:
 *
 *  unsyncrhonized(obj) {
 *     // open region (͓ĂȂƂۏ)
 *     // ....
 *  }
 *
 *  ̃}Nō쐬 Monitor IuWFNg̕ϐ,
 *  'msԍ' ƂȂ. Ⴆ΂̃}Ns 123 sڂƂ,
 *  m123 ̂悤ȖOł.
 *
 */
#define unsynchronized(obj) \
	if (TJMonitor m ## __LINE__  = TJMonitor(obj, TJMonitor::UNLOCK)) ; else


#endif	/* !defined(TJMonitor_h) */
