/*-----------------------------------------------------------------------

      Copyright (c) 1998,1999 Eiwa System Management, Inc

                      All Rights Reserved

  This file contains proprietary source code and other proprietary
  material owned by Eiwa System Management, Inc. Published only in
  limited copyright sence.

------------------------------------------------------------------------*/
/*
 * $Id: TJMonitorTester.cc,v 1.6 1999/07/31 01:45:22 tokui Exp $
 */
#include "TJMonitorTester.h"

#include "TJMonitor.h"
#include "tjiostream.h"

TJMonitorTester::TJMonitorTester(const TJSyncObject* synobj) {
	this->synobj = synobj;
}

TJMonitorTester::TJMonitorTester(const TJMonitor* mon) {
	this->synobj = mon->object;
}

TJMonitorTester::~TJMonitorTester() {
}

TJThread::ID TJMonitorTester::getMonitorOwner() const {
	return synobj->monitorOwner;
}

int TJMonitorTester::getMonitorWant() const {
	return synobj->monitorWant;
}

int TJMonitorTester::getMonitorNest() const {
	return synobj->monitorNest;
}

int TJMonitorTester::getSignalWant() const {
	return synobj->signalWant;
}

ostream& TJMonitorTester::print(ostream& o) const {
	o << " monitorOwner=" << synobj->monitorOwner;
	o << " monitorWant=" << synobj->monitorWant;
	o << " monitorNest=" << synobj->monitorNest;
	o << " signalWant=" << synobj->signalWant;
	o << endl;
	return o;
}
