/*-----------------------------------------------------------------------

      Copyright (c) 1998,1999 Eiwa System Management, Inc

                      All Rights Reserved

  This file contains proprietary source code and other proprietary
  material owned by Eiwa System Management, Inc. Published only in
  limited copyright sence.

------------------------------------------------------------------------*/
/*
 * $Id: TJMutex.cc,v 1.11 1999/07/28 06:02:04 hiranabe Exp $
 */
#include "TJMutex.h"

#include "TJPrimitive.h"
#include "TJSystemInternal.h"
#include "TJThread.h"


#if defined(TJ_THREAD_DEBUG)
	/*
	 * TJThread::classLock  pause ȂD
	 * ƔrƓ̃fobOɓD
	 * TJThread::classLock ̓bNlƑ̂Ȃ郍bN
	 * l҂킹ɑ؂D
	 * ẴbN pause Kv͂ȂD
	 */
#	include "TJThreadDebugger.h"
#	define MUTEXPAUSE(s) if (!nopause) TH_PAUSE(s)
#else
#	define MUTEXPAUSE(s)
#endif


TJMutex::TJMutex() {
	int error = ::TJMutexCreate(&mutex);
	if (error != 0)
		TJSystem_Error("TJMutex::TJMutex", error);
	locked = false;
	nopause = false;
}

TJMutex::~TJMutex() {
	::TJMutexDelete(mutex);
	mutex = 0;
}

void TJMutex::lock() {
	MUTEXPAUSE("before TJMutex::lock");
	int error = ::TJMutexLock(mutex);
	if (error != 0)
		TJSystem_Error("TJMutex::lock", error);
	locked = true;
	MUTEXPAUSE("TJMutex::lock OK");
}

void TJMutex::unlock() {
	MUTEXPAUSE("before TJMutex::unlock");
	locked = false;
	int error = ::TJMutexUnlock(mutex);
	if (error != 0)
		TJSystem_Error("TJMutex::unlock", error);
	//MUTEXPAUSE("TJMutex::unlock OK");
}

bool TJMutex::isLocked() {
	return locked;
}

void TJMutex::suppressPause() {
	nopause = true;
}
