/*-----------------------------------------------------------------------

      Copyright (c) 1998,1999 Eiwa System Management, Inc

                      All Rights Reserved

  This file contains proprietary source code and other proprietary
  material owned by Eiwa System Management, Inc. Published only in
  limited copyright sence.

------------------------------------------------------------------------*/
/*
 * $Id: TJObservable.h,v 1.9 1999/07/28 06:02:09 hiranabe Exp $
 */
#if !defined(TJObservable_h)
#define TJObservable_h

#ifndef tjconfig_h
#include "tjconfig.h"
#endif

class TJObserver;
#include <vector>
#ifndef tjstdnamespace_h
#include "tjstdnamespace.h"
#endif

/**
 * IuU[o[p^[x Observable NX(Subject/Publisher).
 *
 * Observable  Observer ֎g̕ω̒ʒmD
 * Model-View  Model IuWFNg̃NXpD
 *
 * 1 Observable ͕ Observer ƂłDObservable
 * ̓ԂωƂCAvP[V notifyObservers \bh
 * ԂƂɂāCObserver  update ԐړIɋND
 *
 * ʒm̏͋K肳ĂȂD
 *
 * o^ꂽ Observer  delete(fXgN^Ăяo) ɂẮC
 * {Iɂ̓AvP[V̐ӔCƂ邪CI destroyObservers 
 * ĂԂƂőS Observer ɑ΂ delete ĂяoƂłD
 *
 * [bNj]
 *
 * ̃NX́C}`XbhɊւ郍bNSӎȂD
 * Kvł TJSafeObservable D
 *
 * @author hiranabe
 * @date 1999,3/30
 * @see TJObserver
 * @see TJSafeObservable
 */
class TJObservable {
protected:
    typedef vector<TJObserver*> ObserverVector;
    ObserverVector observer;
    bool changed;
public:
    /**
     * RXgN^.
     */
    TJObservable();

    /**
     * Observer ǉ.
     *
     * @param o Observer IuWFNgDnull Ȃ疳D
     */
    virtual void addObserver(TJObserver* o);

    /**
     * Observer 폜.
     *
     * Observer  delete (fXgN^Ăяo)͍sȂD
     *
     * [note]
     * java.util.Observable  deleteObserver Ƃl[~O
     * C++  delete Zq Az閼OȂ̂ŁCremoveObserver ƂD
     *
     * @param o Observer IuWFNg
     */
    virtual void removeObserver(TJObserver* o);

    /**
     * o^Ă邷ׂĂ Observer 폜.
     * ̃\bhĂ΂ꂽCʒmׂ Observer ̃Xg͋ɂȂD
     * e Observer  delete (fXgN^Ăяo)͍sȂD
     */
    virtual void removeObservers();

    /**
     * Observable ̕ω Observer ɒʒm.
     * ω setChanged ŐݒłChasChanged ɂČmCclearChanged
     * ɂăZbg邱ƂłD
     * ̃\bh́Cobserver  update ĂяoD
     * ̍ۂ̑2́C0(NULL) ƂȂD
     *
     * const \bhł͂Ȃ͈̂Ӑ}IłD̃\bh̒ŌĂ΂
     * Observer  update ŁC Observable  non-const \bh
     * Ăׂ悤ɂĂD
     *
     * @see  TJObservable#clearChanged()
     * @see  TJObservable#hasChanged()
     * @see  TJObserver#update()
     */
    virtual void notifyObservers();

    /**
     * Observable ̕ω Observer ɒʒm.
     *
     * ω setChanged ŐݒłChasChanged ɂČmCclearChanged
     * ɂăZbg邱ƂłD
     * ̃\bh́Cobserver  update ĂяoD
     * ̍ۂ̑2́C̃\bhɓn arg łD
     *
     * const \bhł͂Ȃ͈̂Ӑ}IłD̃\bh̒ŌĂ΂
     * Observer  update ŁC Observable  non-const \bh
     * Ăׂ悤ɂĂD
     *
     * @param arg AvP[VŎgpCӂ̃f[^
     * @see TJObservable#clearChanged()
     * @see TJObservable#hasChanged()
     * @see TJObserver#update()
     */
    virtual void notifyObservers(void* arg);

    /**
     * ωǂ.
     *
     * @return  true setChanged Ă΂,܂ʒmĂȂ
     * @see TJObservable#clearChanged()
     * @see TJObservable#setChanged()
     */
    virtual bool hasChanged() const;

    /**
     * ݂ Observer ̐Ԃ.
     *
     * @return ݂ Observer ̐
     */
    virtual unsigned countObservers() const;

    /**
     * o^Ă Observer  delete (fXgN^Ăяo).
     *
     * {I Observer  delete ̓AvP[V̐ӔCƂ邪C
     * AvP[VObserver ̊ǗȂꍇC̃\bh
     *  delete xD
     * Observer ϐ̏ꍇ́CRgpĂ͂ȂȂD
     */
    virtual void destroyObservers() const;

    /**
     * fXgN^.
     *
     * Observer ̃fXgN^͌ĂяoȂƂɒӁD
     *
     * @see TJObservable#destroyObservers()
     */
    virtual ~TJObservable();

    /**
     * XbhZ[tȂ̂ǂ̌.
     *
     * ̃NXgł false łD
     * Observer  notifyObservers sہC̃\bh
     * ̕Ԃlɉ update/safeUpdate ĂѕD
     *
     * @return true XbhZ[t
     */
    virtual bool isSafe() const;

    /**
     * Observer Ă邩ǂ̌.
     *
     * @param o Oberver IuWFNg
     */
    virtual bool hasObserver(const TJObserver* o) const;

protected:
    /**
     * ωƂZbg.
     */
    virtual void setChanged();

    /**
     * ωƂNA.
     * ԕωCׂĂ Observer ɒʒmꂽƂ
     * notifyObservers 玩IɌĂ΂D
     *
     * @see  TJObservable#notifyObservers()
     */
    virtual void clearChanged();

};

#endif	/* !defined(TJObservable_h) */
