/*-----------------------------------------------------------------------

      Copyright (c) 1998,1999 Eiwa System Management, Inc

                      All Rights Reserved

  This file contains proprietary source code and other proprietary
  material owned by Eiwa System Management, Inc. Published only in
  limited copyright sence.

------------------------------------------------------------------------*/
/*
 * $Id: TJQueue.h,v 1.8 1999/07/28 06:02:14 hiranabe Exp $
 */
#if !defined(TJQueue_h)
#define TJQueue_h

#ifndef tjconfig_h
#include "tjconfig.h"
#endif

/**
 * bZ[WL[.
 *
 * ̃NXł́AbZ[WƂ͒̎w肳ꂽoCg̔z̎
 * lB
 * bZ[W~obt@̂ƂL[ƌĂсAL[ɑ΂鑀́C
 * \begin{verbatim}
 *       1. send() - bZ[WM
 *       2. receive() - bZ[WM
 * \end{verbatim}
 * 2łD
 * bZ[W͑M˗̏ŃL[ɒ~B
 * bZ[WMAL[瑗M˗̏œǂݏoA
 * ǂݏoꂽbZ[W̓L[폜B
 * L[͖{NX̃IuWFNgɎw肳ꂽŒTCYł
 * LkȂB
 * ܂AL[̃obt@̈̓L[IuWFNgɓƎɊmۂĂA
 * bZ[WM̈˗󂯂{IuWFNǵAbZ[WL[obt@
 * Rs[BM˗̓L[w肳ꂽbZ[WGA
 * Rs[B
 *
 * āAbZ[WMEM˗͂̃L[IuWFNgƂ͕ʂ
 * bZ[WGÅmہEgōsKvB
 *
 * ܂CbZ[W̑MEM͒PȃRs[ł邽߁C
 * bZ[WPOD^(ISO C++ section 3.9)̃IuWFNgT|[g
 * ȂDȂ킿Cmemcpy() ɂăRs[ۏ؂łf[^^
 * L[đ邱Ƃ͂łȂDvirtual \bh class 
 * IuWFNgȂǂ́C̃|C^𑗎M邱ƂŉzIȐU
 * 邱ƂłD
 *
 * Xbh̃ubNɂ
 *   bZ[WMAL[ɃbZ[WP݂ȂꍇA
 *   receive() ̓ubNB̏ԂŃbZ[WM˗ꍇA
 *   MŃubN receive() AB
 *   AL[ɃbZ[W݂ꍇAubNAB
 *
 *   bZ[WMAL[ɋ󂫂ꍇ(L[̃RXgN^
 *   w肳ꂽő吔̃bZ[Włɒ~ςĂꍇ)̂
 *   ubNBL[ɋ󂫂ꍇAubNAB
 *
 * @author Susumu TOKUI
 * @date 1998,6/1
 */
class TJQueue {

private:
	/*
	 * opaque message queue descriptor
	 */
	void* msgqueue;

	/*
	 * ő僁bZ[W
	 */
	int maxlen;

	/*
	 * POSIX ݊̂߃L[Ƀj[NȖOt.
	 */
	static unsigned serialno;
	char name[32];

public:
	/**
	 * ɑ҂Ƃ萔.
	 */
	static const long INFINITE;

	/**
	 * ҂ȂƂw肷萔.
	 */
	static const long NONBLOCK;

	/**
	 * receive() ̗OIȖ߂l.
	 * milliseconds > 0 Ń^CAEg܂
	 * milliseconds = 0 ŎMf[^݂Ȃ
	 */
	static const int NODATA;

public:
	/**
	 * TJQueue IuWFNg𐶐.
	 *
	 * @param maxmsgs   ő僁bZ[W (maxmsgs > 0)
	 * @param maxmsglen ő僁bZ[W (maxmsglen > 0)
	 */
	TJQueue(int maxmsgs, int maxmsglen);

	/**
	 * TJQueue IuWFNg.
	 */
	virtual ~TJQueue();

	/**
	 * bZ[W𑗐M.
	 *
	 * @param msg    MbZ[W̃AhX
	 * @param length MbZ[W̃oCg (0 < length <= maxmsglen)
	 */
	virtual void send(const void* msg, int length);

	/**
	 * bZ[WM.
	 *
	 * @param msgbuf   MbZ[Wobt@̃AhX
	 * @param bufsize  MbZ[Wobt@̃oCg
	 * @param milliseconds ő҂킹~b
	 *                     INFINITE: ɑ҂
	 *                     NONBLOCK: Mf[^ȂΕA
	 * @return MoCg
	 *   , L[j󂳂ꂽꍇ 0
	 *   milliseconds > 0 Ń^CAEgꍇ TJQueue::NODATA
	 *   milliseconds = 0 ŎMf[^݂Ȃꍇ TJQueue::NODATA
	 */
	virtual int receive(void* msgbuf, int bufsize,
		long milliseconds = INFINITE);
};


#endif	/* !defined(TJQueue_h) */
