/*-----------------------------------------------------------------------

      Copyright (c) 1998,1999 Eiwa System Management, Inc

                      All Rights Reserved

  This file contains proprietary source code and other proprietary
  material owned by Eiwa System Management, Inc. Published only in
  limited copyright sence.

------------------------------------------------------------------------*/
/*
 * $Id: TJRWLock.h,v 1.11 1999/07/28 06:02:15 hiranabe Exp $
 */
#if !defined(TJRWLock_h)
#define TJRWLock_h

#ifndef tjconfig_h
#include "tjconfig.h"
#endif

#ifndef TJMutex_h
#include "TJMutex.h"
#endif
#ifndef TJSync_h
#include "TJSync.h"
#endif
#ifndef TJThread_h
#include "TJThread.h"
#endif

/**
 * Read/Write Lock (LErbN).
 *
 * ʏ푀삪QƂłA܂ɍXV鋤L̂߂̃bNł.
 *
 * \begin{verbatim}
 *   yӁz
 *         ̃NXɂ gՂTJTransaction ƂNX
 *         pӂĂ. TJRWLock 𒼐ڎg킸 TJTransaction gƂ
 *         .
 *         TJTransaction ͂̃NXS߂Ă. 
 *         TJRWLock ̈ꕔ̋@\𐧌Ă.
 * \end{verbatim}
 *
 *
 * ̍XVXbh͍XV[hŃbNlAQƃXbh͎Qƃ[h
 * bNl邱.
 *
 * Qƃ[h̃bN̓JE^ŊǗĂ邽ߓɂm̃Xbh
 * l\ł邪, XV[h̃bN͂P̃Xbĥ݊lł.
 *
 * XV[h̃bNł̓XbhL邽ߓXbhɌ蕡l
 * \ƂĂ.
 *
 * XVEQƂƂɃbN̊lƉ̉񐔂ƂȂ邱Ƃۏ؂邱.
 *
 * XV[h̃bNlɐĕÂ͎Ƃ.
 * \begin{verbatim}
 *     ̃XbhɂXVbNԂłȂAQƃbNԂłȂA
 *     ܂̓JgXbhXV[hŃbN
 * \end{verbatim}
 *
 * Qƃ[h̃bNlɐĕÂ͎Ƃ.
 * \begin{verbatim}
 *     XVbNԂłȂAXVbNvȂ
 *     yӁz̍XVbNvȂƂXVXbh
 *             ҂邱Ƃ͂Ȃ͂ł.
 * \end{verbatim}
 *
 * ALɍvȂꍇɁAXbhubN邩ۂ́A
 * bNl\bh̃p[^Ŏw\łB
 * (beginTransactionmilliseconds)
 *
 * @author Susumu TOKUI
 * @date 1998,6/1
 */
class TJRWLock {

private:
	TJMutex rwlockMutex;	// R/W bNݔrpIuWFNg
	TJSync rlockSync;	// R bNpIuWFNg
	TJSync wlockSync;	// W bNpIuWFNg
	int rlockCount;		// lȂΎQƃ[hŃbN
	int rlockWant;		// Qƃ[h̃bNv҂
	TJThread::ID wlockOwner;	// NonełȂ΍XV[hŃbN
	int wlockNest;		// XV[h̃bÑlXgx
	int wlockWant;		// XV[h̃bNv҂

public:
	/**
	 * TJRWLock IuWFNg쐬.
	 */
	TJRWLock();

	/**
	 * TJRWLock IuWFNg.
	 */
	virtual ~TJRWLock();

	/**
	 * LEr[h.
	 *
	 * SHARED: L[h, EXCLUSIVE: r[h
	 */
	enum LockMode { SHARED, EXCLUSIVE };

	/**
	 * ɑ҂Ƃ萔.
	 */
	static const long INFINITE;

	/**
	 * ҂ȂƂw肷萔.
	 */
	static const long NONBLOCK;

	/**
	 * QƂ܂͍XV[hŃbNl.
	 *
	 * @param mode   SHARED: Qƃ[h, EXCLUSIVE: XV[h
	 * @param milliseconds   ő҂킹~b
	 *                       INFINITE: ɑ҂
	 *                       NONBLOCK: lłȂ΃G[A
	 * @return   true: bN, false: bNs
	 *           milliseconds = INFINITE ̏ꍇ̓bNs̉\͂Ȃ.
	 */
	virtual bool beginTransaction(LockMode mode, long milliseconds);

	/**
	 * bN.
	 */
	virtual void endTransaction();

	/**
	 * XV[hŃbNȂ true Ԃ.
	 *
	 * ̃\bh͌ɂ͂ǂ܂ނJɓ̃\bh
	 * bNČĂяo邱Ƃۏ؂邽߂Ɏg.
	 * @return bNĂ true
	 */
	virtual bool isWLocked() const;

	/**
	 * Qƃ[hŃbNȂ true Ԃ.
	 *
	 * ̃\bh͌ɂ͂ǂ܂ނJɓ̃\bh
	 * bNČĂяo邱Ƃۏ؂邽߂Ɏg.
	 * @return bNĂ true
	 */
	virtual bool isRLocked() const;

	/**
	 * sϏ.
	 *
	 * J assert() ̈Ƃėpł.
	 * @return IuWFNg̏ԂɖȂ true
	 */
	virtual bool invariant() const;
};


#endif	/* !defined(TJRWLock_h) */
