/*-----------------------------------------------------------------------

      Copyright (c) 1998,1999 Eiwa System Management, Inc

                      All Rights Reserved

  This file contains proprietary source code and other proprietary
  material owned by Eiwa System Management, Inc. Published only in
  limited copyright sence.

------------------------------------------------------------------------*/
/*
 * $Id: TJSemaphore.cc,v 1.5 1999/07/28 06:02:25 hiranabe Exp $
 */

#include "TJSemaphore.h"

#include "tjdebug.h"


/**
 * Z}tHNX
 *
 * TJSyncObject gR[fBÔ͎悤ɂȂ邾낤\l
 * TJMutex  TJSync Ŏ邱ƂɂD
 *
 *	class TJSemaphore {
 *		TJSyncObject semlock;
 *		int semvalue;
 *		bool waiting;
 *
 *	    public:
 *		TJSemaphore(int inivalue = 0) : semlock() {
 *			semvalue = inivalue;
 *			waiting = false;
 *		}
 *
 *		virtual ~TJSemaphore() { }
 *
 *		void take() {
 *			TJMonitor synchro__(&semlock);
 *			while (semvalue <= 0) {
 *				waiting = true;
 *				semlock.wait();
 *				waiting = false;
 *			}
 *			semvalue--;
 *		}
 *
 *		void give() {
 *			TJMonitor synchro__(&semlock);
 *			semvalue++;
 *			if (waiting)
 *				semlock.notify();
 *		}
 *	}
 *
 * VxWorks lƃZ}tHv~eBuɂȂ邪Cv~eBu
 * ͏Ȃ悢D
 *
 * TJSyncObject ̂悤ɍċAIɃbNɂ邱Ƃ͑z肵ĂȂD
 * ̂悤ȑΏKvƂΐ݌v邢ׂ͎łD
 */


const long TJSemaphore::INFINITE = (long)(-1);
const long TJSemaphore::NONBLOCK = (long)0;

/**
 * TJSemaphore 쐬D
 */
TJSemaphore::TJSemaphore(int inivalue /*=0*/) : mutex(), sync(&mutex) {
	semvalue = inivalue;
	waiting = false;
}

/**
 * TJSemaphore D
 */
TJSemaphore::~TJSemaphore() {
}

/**
 * Semaphore 擾D
 */
void TJSemaphore::take() {

	mutex.lock();

	while (semvalue <= 0) {
		waiting = true;
		sync.wait();
		waiting = false;
	}

	semvalue--;

	mutex.unlock();
}

/**
 * ^CAEgw肵 Semaphore 擾D
 */
bool TJSemaphore::take(long milliseconds) {

	require(milliseconds >= (long)0 || milliseconds == INFINITE);

	if (milliseconds == INFINITE) {
		take();
		return true;	// Semaphore 擾
	}

	mutex.lock();

	if (milliseconds == NONBLOCK) {
		bool success = semvalue > 0;
		if (success)
			semvalue--;
		mutex.unlock();
		return success;	// true Ȃ Semaphore 擾
	}

	while (semvalue <= 0) {
		waiting = true;
		bool signaled = sync.timedwait(milliseconds);
		waiting = false;
		if (!signaled) {
			mutex.unlock();
			return false;	// ^CAEg
		}
	}

	semvalue--;

	mutex.unlock();
	return true;	// Semaphore 擾
}

/**
 * Semaphore ^D
 */
void TJSemaphore::give() {

	mutex.lock();

	semvalue++;

	if (waiting) {
		mutex.unlock();
		sync.signal();
		return;
	}

	mutex.unlock();
}
