/*-----------------------------------------------------------------------

      Copyright (c) 1998,1999 Eiwa System Management, Inc

                      All Rights Reserved

  This file contains proprietary source code and other proprietary
  material owned by Eiwa System Management, Inc. Published only in
  limited copyright sence.

------------------------------------------------------------------------*/
/*
 * $Id: TJSemaphore.h,v 1.10 1999/07/28 06:02:26 hiranabe Exp $
 */
#if !defined(TJSemaphore_h)
#define TJSemaphore_h

#ifndef tjconfig_h
#include "tjconfig.h"
#endif

#ifndef TJMutex_h
#include "TJMutex.h"
#endif
#ifndef TJSync_h
#include "TJSync.h"
#endif


/**
 * Z}tHNX.
 *
 * ̃NX̓oCiZ}tH邢͌v^Z}tHƂĎg.
 * ʓIȔrE̖ł. ̃NX̃IuWFNg
 * 쐬鎞ɂ͏ldvł. q̗Q.
 *
 * ʏAʓIȔrE̖邽߂ɂ́ATJSyncObject
 * p邱Ƃ𐄏B
 *
 * ꕔATJSyncObject  TJSemaphore ӂ킵Ȃ
 * 񓯊o͊̓l.
 * ʓIɂ͔񓯊o͂gR͏o͗v
 * . ƂƂ͓̃^C~Oł͂łɔ񓯊o͂Ă
 * \邱ƂɂȂ TJSyncObject  wait() ł͂ł notify()
 * ĂȂTdɔfȂ΂ȂȂ.
 * ̓_ TJSemaphore  take()  give() ̎sƂ͖֌Wɓ
 * Ƃ. Ă̖ɂ̓Z}tHKĂ.
 *
 * \begin{verbatim}
 * g̗
 *
 *   Pȓ̏ꍇ
 *
 *       Z}tH͏l 0 Ƃ. ̃IuWFNg͓Ƃ
 *       Q̃XbhmĂ̂Ƃ.
 *
 *           TJSemaphore sem(0);  // l 0 dv
 *
 *       ҂Xbh
 *
 *           sem.take();
 *
 *       s. }Xbh
 *
 *           sem.give();
 *
 *       s邱Ƃɂ҂ĂXbhڊo߂.
 *       ̃P[Xł͍}Xbh give() sĂ
 *       ͋NȂ. P take() ubNꂸɕA
 *       ł.  TJSyncObject  wait() Ăяo notify()
 *       邱ƂvO}ۏ؂Ȃ΂ȂȂ. ʏ킻
 *       ͂P̏ԕϐŗeՂɎł. TJSemaphore ͂̏
 *       ԕϐɎĂ邽 give() ɑƂ
 *       take() m邱ƂłƍlƗ₷.
 *
 *   ȑꍇ
 *
 *       ̏ꍇ͏l 1 Ƃ邱Ƃdvł.
 *
 *           TJSemaphore sem(1);  // l 1 dv
 *
 *       Xbh͎̕@ critical region ł.
 *
 *           sem.take();
 *           // critical region
 *           // ŋL𑀍삷.
 *           sem.give();
 * \end{verbatim}
 *
 * @author Susumu TOKUI
 * @date 1998,6/1
 */
class TJSemaphore {

private:
	TJMutex mutex;		// ݔrpIuWFNg
	TJSync sync;		// pIuWFNg
	int semvalue;
	bool waiting;

public:
	/**
	 * ɑ҂Ƃ萔.
	 */
	static const long INFINITE;

	/**
	 * ҂ȂƂw肷萔.
	 */
	static const long NONBLOCK;

public:
	/**
	 * TJSemaphore 쐬.
	 *
	 * @param inivalue l
	 */
	TJSemaphore(int inivalue = 0);

	/**
	 * TJSemaphore .
	 */
	virtual ~TJSemaphore();

	/**
	 * Semaphore 擾.
	 * sĂꍇ̓ubN.
	 */
	void take();

	/**
	 * ^CAEgw肵 Semaphore 擾.
	 * ^CAEgw肹sĂꍇ̓ubN.
	 * @param milliseconds ő҂킹~b
	 *                     INFINITE: ɑ҂
	 *                     NONBLOCK: 擾łȂ false ŕA
	 * @return true: 擾ł false: ^CAEg
	 */
	bool take(long milliseconds);

	/**
	 * Semaphore ^.
	 * ҂ĂXbh΃fBɂ.
	 */
	void give();
};


#endif	/* !defined(TJSemaphore_h) */
