/*-----------------------------------------------------------------------

      Copyright (c) 1998,1999 Eiwa System Management, Inc

                      All Rights Reserved

  This file contains proprietary source code and other proprietary
  material owned by Eiwa System Management, Inc. Published only in
  limited copyright sence.

------------------------------------------------------------------------*/
/*
 * $Id: TJSyncObject.cc,v 1.8 1999/07/28 06:02:32 hiranabe Exp $
 */
#include "TJSyncObject.h"

#include "TJPrimitive.h"
#include "tjdebug.h"

#if defined(TJ_THREAD_DEBUG)
#	include "TJThreadDebugger.h"
#else
#	define TH_PUSHNAME(s)
#	define TH_POPNAME()
#endif


/**
 * TJSyncObject 쐬D
 */
TJSyncObject::TJSyncObject()
		: monitorMutex(), monitorSync(&monitorMutex),
		  signalMutex(), signalSync(&signalMutex) {
	monitorOwner = TJThread::None;
	monitorNest = 0;
	monitorWant = 0;
	signalWant = 0;
}

/**
 * TJSyncObject ̃Rs[RXgN^
 *
 * Ӗ͈𖳎ĐVK쐬Ƃ.
 */
TJSyncObject::TJSyncObject(const TJSyncObject& /*obj*/)
		: monitorMutex(), monitorSync(&monitorMutex),
		  signalMutex(), signalSync(&signalMutex) {
	monitorOwner = TJThread::None;
	monitorNest = 0;
	monitorWant = 0;
	signalWant = 0;
}

/**
 * Z
 *
 * Ӗ "ɑ΂ẴIuWFNg͕ωȂ" ł.
 */
TJSyncObject& TJSyncObject::operator=(const TJSyncObject& /*obj*/) {
	return *this;
}

/**
 * TJSyncObject D
 */
TJSyncObject::~TJSyncObject() {
}

/**
 * j^Iy[V̂߂̔rbNlD
 *
 * ̃bNVXe@\̔rbN(TJMutex)ɒPɃ}bsO
 * R͎̂ƂłD
 * ylzj^Iy[V Java  synchronized method ƓǊ
 *         Ă悢D
 *
 * ʏ͉L̎֎~͂Ȃ͂łD
 *
 *   j^Iy[V̍ċAďo (͂Ȃ)
 *   j^Iy[V̒瓯IuWFNg̕ʂ̃j^
 *     Iy[Vďo
 *   KvȃbNl鋤ʃ[`Sč邱
 *
 * ̗v𖞂߂ɂ͓XbhɌ艽xłl\ȃbN
 * KvłD
 * CVXe@\̔rbN͈ʓIɂ̗͂v𖞂Ȃƍl
 * ׂłD (POSIX dlł̓fbhbNƂȂ)
 * ĈʓIȃVXe@\găAvP[VxŃbN
 * D
 *
 * ჌x̃vOŃfbhbN̉ۏ؂łȂΐ\̂
 *  TJMutexgĂ悢ClԂ͖Y₷̂łD
 *
 * rƖ֌Wȓ@\VXe݂邪, ł POSIX Xbh
 * (܂java)̍l̗p, L̎g.
 * ܂蓯ɂ͋Lی̂߂̃bNKvƂ.
 * ƒPȓ̂߂ɂ̓Z}tHNX(TJSemaphore)g邩ǂ
 * 鉿l.
 *
 */
void TJSyncObject::lock() {
	TH_PUSHNAME("TJSyncObject::lock");

	TJThread::ID curtid = TJThread::currentThreadID();

	monitorMutex.lock();

	if (monitorOwner == curtid) {
		/*
		 * JgXbhbN
		 */
		monitorNest++;
	} else {
		while (monitorOwner != TJThread::None) {
			/*
			 * ʂ̃XbhbN
			 */
			monitorWant++;
			monitorSync.wait();
		}
		/*
		 * NbNĂȂ
		 */
		monitorOwner = curtid;
		monitorNest = 1;
	}

	ensure(consistent());

	monitorMutex.unlock();

	TH_POPNAME();
}

/**
 * j^Iy[V̂߂̔rbND
 *
 * notify̑ĂƂ
 *
 *     if (monitorWant > 0) {
 *             monitorWant = 0;
 *             monitorSync.broadcast();
 *     }
 *
 * l邪CPUԂ̘QJo[郁bgvȂD
 */
void TJSyncObject::unlock() {
	TH_PUSHNAME("TJSyncObject::unlock");

	TJThread::ID curtid = TJThread::currentThreadID();

	monitorMutex.lock();

	assert(monitorOwner == curtid);
	monitorNest--;
	assert(monitorNest >= 0);

	if (monitorNest == 0) {
		monitorOwner = TJThread::None;
		if (monitorWant > 0) {
			monitorWant--;
			/*
			 * signal() sO unlock() D
			 */
			ensure(consistent());
			monitorMutex.unlock();
			monitorSync.signal();
			TH_POPNAME();
			return;
		}
	}

	ensure(consistent());

	monitorMutex.unlock();

	TH_POPNAME();
}


/**
 * wait .
 *
 * j^bNO signalMutex.lock() sȂ signalSync.signal()
 * ɑĂ܂ signalSync.wait() ivɖڊo߂ȂguN.
 */
bool TJSyncObject::waitOperation(bool timeout, long milliseconds) {
	bool signaled = true;

	TJThread* curthread = TJThread::currentThread();
	TJThread::ID curtid = curthread->getThreadID();
	/*
	 * ł̓oOŃj^bNĂȂȂD
	 * ǂ̂悤ȃVXeł if ɂ monitorOwner 
	 * Ǐo̓Ag~bNɂȂ͂D
	 */
	assert(monitorOwner == curtid);

	signalMutex.lock();	// 샍bNl

	int lockcount = monitorNest;	// j^bNĂ邩QƉ\
	/*
	 * j^bND
	 */
	for (int n = lockcount; n > 0; n--)
		this->unlock();

	//curthread->setState(TJThread::WAIT, this);	// WAITԂɐݒ
	signalWant++;
	/*
	 * őҋ@D
	 *   ̑ҋ@Ԃł͓샍bN͎IɉD
	 *   ̃IuWFNg notify(), notifyAll() 邩܂
	 *   ^CAEgݒ莞Ƀ^CAEgƂҋ@D
	 *   Aɂ͓샍bN͊lĂD
	 */
	if (timeout)
		signaled = signalSync.timedwait(milliseconds);
	else
		signalSync.wait();
	//curthread->setState(TJThread::RUN);	// RUNԂɖ߂

	signalMutex.unlock();	// 샍bN

	/*
	 * j^bNēxlD
	 * Uj^bNΐɎc N-1 񃍃bNKv͂ȂD
	 */
	this->lock();
	monitorNest = lockcount;

	return signaled;
}

void TJSyncObject::notifyOperation(bool all) {
	TJThread::ID curtid = TJThread::currentThreadID();
	/*
	 * ł̓oOŃj^bNĂȂȂD
	 * ǂ̂悤ȃVXeł if ɂ monitorOwner 
	 * Ǐo̓Ag~bNɂȂ͂D
	 */
	assert(monitorOwner == curtid);

	signalMutex.lock();	// 샍bN

	if (signalWant > 0) {
		if (all) {
			signalWant = 0;
			/*
			 * broadcast() sO unlock() D
			 */
			signalMutex.unlock();
			signalSync.broadcast();
			return;
		} else {
			signalWant--;
			/*
			 * signal() sO unlock() D
			 */
			signalMutex.unlock();
			signalSync.signal();
			return;
		}
	}

	signalMutex.unlock();
}


void TJSyncObject::wait() {
	TH_PUSHNAME("TJSyncObject::wait");
	(void)waitOperation(false, 0);
	TH_POPNAME();
}

bool TJSyncObject::wait(long milliseconds) {
	TH_PUSHNAME("TJSyncObject::wait(ms)");
	bool signaled = true;
	if (milliseconds <= (long)0)
		(void)waitOperation(false, 0);
	else
		signaled = waitOperation(true, milliseconds);
	TH_POPNAME();
	return signaled;
}

void TJSyncObject::notify() {
	TH_PUSHNAME("TJSyncObject::notify");
	notifyOperation(false);
	TH_POPNAME();
}

void TJSyncObject::notifyAll() {
	TH_PUSHNAME("TJSyncObject::notifyAll");
	notifyOperation(true);
	TH_POPNAME();
}

/**
 * fireEvent() ďô߂ɈꎞIɃbND
 *
 * ̏̓JgXbhbN̏ꍇ̂݃bN邱Ƃ
 * ӂ邱ƁDʂ̃XbhbNƂāC̉҂킹Ă
 * ӖȂDȂȂ΃bNԂł͂łRɕʂ̃Xbh
 * ăbNls邩łD
 * ̃\bḧӐ}͒ʏ̃bNKwƂ͋t̃bNl邽
 * ߁CȂƂt[[N fireEvent()ďo̓bN
 * 悤Ƃ̂łD
 *
 * wait()ďoĂXbh̓j^bNĂ͂
 * ͕svłD
 */
int TJSyncObject::unlockTemporarily() {
	TH_PUSHNAME("TJSyncObject::unlockTemporarily");

	TJThread::ID curtid = TJThread::currentThreadID();
	int lockcount = 0;

	monitorMutex.lock();

	if (monitorOwner == curtid) {
		/*
		 * JgXbhbN
		 * bN񐔂XbhɋLĂɎw
		 */
		lockcount = monitorNest;
		monitorNest = 0;
		monitorOwner = TJThread::None;
		if (monitorWant > 0) {
			/*
			 * łׂ͂ĂfBɂׂ
			 */
			monitorWant = 0;
			/*
			 * broadcast() sO unlock() D
			 */
			ensure(consistent());
			monitorMutex.unlock();
			monitorSync.broadcast();
			TH_POPNAME();
			return lockcount;
		}
	}

	ensure(consistent());

	monitorMutex.unlock();

	TH_POPNAME();
	return lockcount;
}

/**
 * fireEvent() ďô߂ɈꎞIɉĂbN𕜌D
 */
void TJSyncObject::restoreLock(int lockcount) {
	TH_PUSHNAME("TJSyncObject::restoreLock");

	if (lockcount > 0) {
		this->lock();
		if (lockcount > 1)
			monitorNest = lockcount;
	}

	TH_POPNAME();
}

bool TJSyncObject::invariant() const {
	monitorMutex.lock();
	bool success = consistent();
	monitorMutex.unlock();
	return success;
}

bool TJSyncObject::consistent() const {
	assert(monitorOwner == TJThread::None && monitorNest == 0
		|| monitorOwner != TJThread::None && monitorNest > 0);
	return true;
}
