/*-----------------------------------------------------------------------

      Copyright (c) 1998,1999 Eiwa System Management, Inc

                      All Rights Reserved

  This file contains proprietary source code and other proprietary
  material owned by Eiwa System Management, Inc. Published only in
  limited copyright sence.

------------------------------------------------------------------------*/
/*
 * $Id: TJSyncObject.h,v 1.13 1999/07/28 06:02:34 hiranabe Exp $
 */
#if !defined(TJSyncObject_h)
#define TJSyncObject_h

#ifndef tjconfig_h
#include "tjconfig.h"
#endif

#ifndef TJMutex_h
#include "TJMutex.h"
#endif
#ifndef TJSync_h
#include "TJSync.h"
#endif
#ifndef TJThread_h
#include "TJThread.h"
#endif

/**
 * XbhԂ̔rEړIƂNX.
 *
 * ̃NX͔r܂͓KvƂꍇ̊{Iȋ@\񋟂.
 *
 * {IȃJjY java Ɠl, j^Əϐɂ̂ł.
 * ̃NXpNX java.lang.Object Ɠl synchronized 
 * ubNƂłC wait / notify ɂXbhԂ̓
 * \ƂȂ. java łׂ͂ẴIuWFNg
 * , ̃Cuł TJSyncObject ƂēƗČpȂǂ
 * 肱̐t(mix-in)jƂ.
 *
 * {Iɂ́C̃NX virtual pĎgpD΁C
 * ̃Z}eBNX java.lang.Object ̃TuNXƓlɂȂD
 *
 * \begin{verbatim}
 *     yz class Xxx : virtual public TJSyncObject { ... }
 * \end{verbatim}
 *
 * Ӗ̈قȂ镡̃bN1IuWFNgŕKvȏꍇɂ́C
 * ̃NX̃IuWFNgCX^XϐƂĕ܂g\ł.
 * CIuWFNg̒ɕ TJSyncObject ܂܂ꍇ, 
 * bNlĈӐ}ȂrƂȂ\邽߁Cӂ
 * KvłD
 *
 * TJSyncObject ͎̂悤ȋ@\Ă.
 * \begin{verbatim}
 *   ̃NX̃TuNX̃\bh̐擪 lock() ĂяoƂɂ
 *     ̃\bh̓j^Iy[VƂȂ.
 *     Ńj^Iy[VƂ java  synchronized \bhƍl
 *     悢. ǂ̃\bhj^Iy[VƂ邩 java ƓlvO
 *     }̑Iɂ܂.
 *
 *   Xbh̓j^Iy[Vs͂̃IuWFNgɑ΂rI
 *     ȃANZXۏ؂.
 *
 *   j^Iy[V̒ wait() sƔrIANZX
 *     ăubÑXbhɂ notify() ďo܂ő҂.
 *
 *   ̃Xbhɂ notify() ďoɂĐ𓾂͍ĂєrIA
 *     NZXlĂ.
 *
 * j^Iy[V̂߂̔rbN͓XbhȂ΃lXg邱
 * \ł. wait() ł̓lXgꂽbN notify() ł̓lXg
 * x܂߂ăbNԂ𕜌.
 * ăj^Iy[V̒ŕʂ̃j^Iy[VĂяo
 * \łD̎dĺCjava.lang.Object ƓlłD
 *
 * C̃NX protected \bh(lock(), unlock(), ...)
 * ͒ڌĂяo TJMonitor NX synchronized }NoR
 * gƂ𐄏.
 * TJMonitor NX synchronized }N, S
 * hLg߂Ă.(TJMonitor Q)
 *
 * java.lang.Object ̎dlQlɂĂ邽ߎ̂悤Ȏgz肵Ă.
 *
 *           java                             TJSyncObject
 * -----------------------------------------------------------
 *     synchronized void method() {           void method() {
 *                                                lock();
 *           EEE                               EEE
 *                                                unlock();
 *     }                                      }
 * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
 *     synchronized void method() {           void method() {
 *                                                lock();
 *           EEE                                 EEE
 *         while (busy)                           while (busy)
 *             wait(); // catch ȗ                  wait();
 *         // object 𑀍                       // object 𑀍
 *           EEE                                 EEE
 *                                                unlock();
 *     }                                      }
 * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
 *     synchronized void method() {           void method() {
 *                                                lock();
 *           EEE                                 EEE
 *         notify();                              notify();
 *           EEE                                 EEE
 *                                                unlock();
 *     }                                      }
 * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
 *     synchronized (obj) {                   obj.lock();
 *           EEE                             EEE
 *     }                                      obj.unlock();
 * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
 *     synchronized (obj) {                   obj.lock();
 *           EEE                             EEE
 *         while (obj.busy)                   while (obj.busy)
 *             obj.wait(); // catch ȗ          obj.wait();
 *         // obj 𑀍                      // obj 𑀍
 *           EEE                             EEE
 *     }                                      obj.unlock();
 * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
 *     synchronized (obj) {                   obj.lock();
 *           EEE                             EEE
 *         obj.notify();                      obj.notify();
 *           EEE                             EEE
 *     }                                      obj.unlock();
 * -----------------------------------------------------------
 * \end{verbatim}
 *
 * L synchronized ubNL@ɂăT|[ǵC
 * TJMonitor QƂ̂ƁD
 *
 * ܂CunlockTemporarily(), restoreLock()  java ɂ݂͑Ȃ@\
 * łD́Csynchronized ubNɁCbNOƂł
 * @\łDjava ł́Csynchronized ubNƂ synchronized
 * ł邱Ƃ͕ۏ؂ł邪CtɌĂяõlXg֌WɂR[h
 * 镔 synchronized O邱Ƃ͕ۏ؂łȂD
 * 
 * ̋@\ɂCfbhbN̉̂߂̃bN̏(Kw)
 * _IɃT|[g邱ƂłD
 *
 * @author Susumu TOKUI
 * @date 1998,6/1
 * @see TJMonitor
 */
class TJSyncObject {

private:
	friend class TJMonitor;
	friend class TJMonitorTester;

	mutable TJMutex monitorMutex;	// j^bNݔrpIuWFNg
	TJSync monitorSync;		// j^bNpIuWFNg
	int monitorWant;
	TJThread::ID monitorOwner;
	int monitorNest;

	TJMutex signalMutex;	// wait/notifyݔrpIuWFNg
	TJSync signalSync;	// wait/notifypIuWFNg
	int signalWant;

public:
	/**
	 * TJSyncObject IuWFNg쐬.
	 */
	TJSyncObject();

	/**
	 * TJSyncObject ̃Rs[RXgN^.
	 *
	 * ̃IuWFNg𖳎ĐVK쐬.
	 * @param obj 
	 */
	TJSyncObject(const TJSyncObject& obj);

	/**
	 * Z.
	 *
	 * ɑ΂ẴIuWFNgωȂ.
	 * @param obj 
	 */
	TJSyncObject& operator=(const TJSyncObject& obj);

	/**
	 * TJSyncObject IuWFNg.
	 */
	virtual ~TJSyncObject();

	/**
	 * ̃Xbh notify 𖳌ɑ҂킹.
	 * wait(0)Ɠ`D
	 */
	void wait();

	/**
	 * ̃Xbh notify őw莞ԑ҂킹.
	 * @param milliseconds   ~b (wait(0)  wait() Ɠ)
	 * @return true:  notify ꂽ, false: ^CAEg
	 */
	bool wait(long milliseconds);

	/**
	 * ̃IuWFNgő҂Ă鑼̃Xbhɒʒm.
	 * ̃IuWFNg wait Ă鑼̃Xbh́C
	 * wait 畜ACs\ƂȂD
	 */
	void notify();

	/**
	 * ̃IuWFNgő҂Ă鑼ׂ̂ẴXbhɒʒm.
	 * ̃IuWFNg wait Ă鑼̃Xbh́C
	 * wait 畜ACs\ƂȂD
	 */
	void notifyAll();

	/**
	 * sϏ.
	 *
	 * TuNXł́C̃\bhpĎȈѐ`FbN
	 * Ƃ𐄏D
	 * J assert() ̈Ƃėpł.
	 * @return IuWFNg̏ԂɖȂ true
	 */
	virtual bool invariant() const;

protected:
	/**
	 * ̃IuWFNg̔rbNl.
	 * Java  synchronized method ܂ synchronized block .
	 */
	void lock();

	/**
	 * ̃IuWFNg̔rbN.
	 */
	void unlock();

	/**
	 * ꎞIɃbN.
	 * @return restoreLock ɓnl(bNlXg)
	 * @see TJSyncObject#restoreLock()
	 */
	int unlockTemporarily();

	/**
	 * ꎞIɉĂbN𕜌.
	 * @param unlockTemporarily ̕Ԓl
	 * @see TJSyncObject#unlockTemporarily()
	 */
	void restoreLock(int lockcount);

private:
	bool waitOperation(bool timeout, long milliseconds);
	void notifyOperation(bool all);
	bool consistent() const;
};


#endif	/* !defined(TJSyncObject_h) */
