/*-----------------------------------------------------------------------

      Copyright (c) 1998,1999 Eiwa System Management, Inc

                      All Rights Reserved

  This file contains proprietary source code and other proprietary
  material owned by Eiwa System Management, Inc. Published only in
  limited copyright sence.

------------------------------------------------------------------------*/
/*
 * $Id: TJSysError.h,v 1.6 1999/07/28 06:02:36 hiranabe Exp $
 */
#if !defined(TJSysError_h)
#define TJSysError_h

#ifndef tjconfig_h
#include "tjconfig.h"
#endif

#if defined(__cplusplus)
extern "C" {
#endif

/**
 * ̃VXe~.
 *
 * @param file __FILE__ 
 * @param line __LINE__ 
 * @param G[bZ[W
 * @see TJSetErrorHandler()
 * @see TJSsetOutputHandler()
 */
extern void TJInconsistentPanic(const char* file, int line, const char* msg);

/**
 * ǧ (sȂ) ̃VXe~.
 *
 * @param file __FILE__ 
 * @param line __LINE__ 
 * @param G[bZ[W
 * @see TJSetErrorHandler()
 * @see TJSsetOutputHandler()
 */
extern void TJInvalidPanic(const char* file, int line, const char* msg);

/**
 * vbgz[ˑVXeR[G[̒~.
 *
 * @param file __FILE__ 
 * @param line __LINE__ 
 * @param G[bZ[W
 * @see TJSetErrorHandler()
 * @see TJSsetOutputHandler()
 */
extern void TJErrorPanic(const char* file, int line, const char* msg, int err);

/**
 * s̃VXe~.
 *
 * @param file __FILE__ 
 * @param line __LINE__ 
 * @param G[bZ[W
 * @see TJSetErrorHandler()
 * @see TJSsetOutputHandler()
 */
extern void TJNomemPanic(const char* file, int line, const char* msg);

/**
 * xbZ[Wo.
 * yӁz͑sD
 *
 * @param file __FILE__ 
 * @param line __LINE__ 
 * @param G[bZ[W
 * @see TJSetErrorHandler()
 * @see TJSsetOutputHandler()
 */
extern void TJPrintWarning(const char* file, int line, const char* msg);

/**
 * O݃G[.
 * yӁz͑sD
 *
 * @param file __FILE__ 
 * @param line __LINE__ 
 * @param G[bZ[W
 * @see TJSetErrorHandler()
 * @see TJSsetOutputHandler()
 */
extern void TJLogFailWarning(const char* file, int line, const char* msg);

/* ------------------------------------------------------------------- */
/**
 * Õnh֐ݒ肷.
 *
 * ݒȂ abort() ̌ĂяoƂȂD
 *
 * @param errorHandler G[nh
 */
extern void TJSetErrorHandler(void (*errorHandler)(void));

/**
 * ُ탁bZ[Wo͊֐̃Zbg.
 *
 * ÕbZ[Wo͗p֐w肷.
 * wȂ stderr ɏo͂D
 *
 * @param outputHandler G[nh
 */
extern void TJSetOutputHandler(void (*outputHandler)(const char*));

#define TJNomem(s)         TJNomemPanic(__FILE__, __LINE__, s)
#define TJInconsistent(s)  TJInconsistentPanic(__FILE__, __LINE__, s)
#define TJInvalid(s)       TJInvalidPanic(__FILE__, __LINE__, s)
#define TJError(s, e)      TJErrorPanic(__FILE__, __LINE__, s, e)
#define TJWarning(s)       TJPrintWarning(__FILE__, __LINE__, s)
#define TJLogFailure(s)    TJLogFailWarning(__FILE__, __LINE__, s)


#if defined(__cplusplus)
}
#endif


#endif	/* !defined(TJSysError_h) */
