/*-----------------------------------------------------------------------

      Copyright (c) 1998,1999 Eiwa System Management, Inc

                      All Rights Reserved

  This file contains proprietary source code and other proprietary
  material owned by Eiwa System Management, Inc. Published only in
  limited copyright sence.

------------------------------------------------------------------------*/
/*
 * $Id: TJSystemInternal.cc,v 1.4 1999/07/28 06:02:37 hiranabe Exp $
 */
#include "TJSystemInternal.h"

#include "TJSysError.h"
#include "TJPrimitive.h"
#include "tjdebug.h"

void TJSystemInternal::exit(int exitcode) {
	::TJSystemExit(exitcode);
}

void TJSystemInternal::setErrorHandler(void (*hndlr)(void)) {
	::TJSetErrorHandler((void (*)(void))hndlr);
}

void TJSystemInternal::setOutputHandler(void (*out)(const char*)) {
	::TJSetOutputHandler(out);
}

void TJSystemInternal::nomemPanic(const char* file, int line, const char* msg) {
	::TJNomemPanic(file, line, msg);
}

void TJSystemInternal::inconsistentPanic(const char* file, int line,
		const char* msg) {
	::TJInconsistentPanic(file, line, msg);
}

void TJSystemInternal::invalidPanic(const char* file, int line, const char* msg) {
	::TJInvalidPanic(file, line, msg);
}

void TJSystemInternal::errorPanic(const char* file, int line, const char* msg,
		int error /*=0*/) {
	::TJErrorPanic(file, line, msg, error);
}

void TJSystemInternal::printWarning(const char* file, int line, const char* msg) {
	::TJPrintWarning(file, line, msg);
}

void TJSystemInternal::logFailWarning(const char* file, int line, const char* msg) {
	::TJLogFailWarning(file, line, msg);
}
