/*-----------------------------------------------------------------------

      Copyright (c) 1998,1999 Eiwa System Management, Inc

                      All Rights Reserved

  This file contains proprietary source code and other proprietary
  material owned by Eiwa System Management, Inc. Published only in
  limited copyright sence.

------------------------------------------------------------------------*/
/*
 * $Id: TJSystemInternal.h,v 1.6 1999/07/28 06:02:39 hiranabe Exp $
 */
#if !defined(TJSystemInternal_h)
#define TJSystemInternal_h

#ifndef tjconfig_h
#include "tjconfig.h"
#endif

/**
 * ThreadJack ̎s, G[CI񋟂NX.
 *
 * ̃NX́CThreadJack ŃfobOpCG[pɗp
 * ĂDAvP[V́C̃NXgpĂ悢C
 * ɎgpȂĂ悢D
 * AvP[VfobOɁCG[⑫CbZ[W̏o͐
 * ύX邽߂ɁC
 *
 *    setErrorHandler(),  setOutputHandler()
 *
 * gp邱ƂlĂD
 *
 * ̃\bh̓ftHgł̓bZ[Wo͂ abort() ĂяoD
 *
 *     nomemPanic(), inconsistentPanic(), invalidPanic(), errorPanic()
 *
 * Cnh setErrorHandler() Őݒ肷ƁCL֐
 * bZ[Wo͌ɃnhɐڂD
 * nhAƂĂ ::abort() Ăяo, 
 * s͕s\łDɑ΂
 *
 *                   printWarning()
 *
 * ̓bZ[Wo͂ČĂяoɕAD
 * L̂̃\bhbZ[W̃ftHg̏o͕͐WG[
 * o͂ł邪CsetOutputHandler() ɂCӂC֐ĂяoɕύXłD
 *
 * ̃NX̎Iȋ@\ "TJSysError.c" ɕĂāCł
 * C ꂩ璼ڌĂяo`̊֐ĂD̃NXł́C
 * ȋ@\ C++ ɒ񋟂D
 */
class TJSystemInternal {
protected:
	/**
	 * CX^Xh
	 */
	TJSystemInternal();

public:
	/**
	 * vZXI.
	 *
	 * ::exit() ĂяôƓʁD
	 *
	 * @param exitcode vZXIR[h
	 */
	static void exit(int exitcode);

	/**
	 * ̓ʏ.
	 * ̃\bh͒ڎgpCNX̃}NgpD
	 *
	 * nh́CsetErrorHandler() ŃZbgD
	 *
	 * @param file __FILE__ 
	 * @param line __LINE__ 
	 * @param G[bZ[W
	 * @see TJSystemInternal#setErrorHandler()
	 * @see TJSystemInternal#setOutputHandler()
	 */
	static void inconsistentPanic(const char* file, int line,
                                  const char* msg);
	/**
	 * ǧ(sȂ)̓ʏ.
	 * ̃\bh͒ڎgpCNX̃}NgpD
	 *
	 * nh́CsetErrorHandler() ŃZbgD
	 *
	 * @param file __FILE__ 
	 * @param line __LINE__ 
	 * @param G[bZ[W
	 * @see TJSystemInternal#setErrorHandler()
	 * @see TJSystemInternal#setOutputHandler()
	 */
	static void invalidPanic(const char* file, int line,
                             const char* msg);
	/**
	 * vbgz[ˑVXeR[G[̓ʏ.
	 * ̃\bh͒ڎgpCNX̃}NgpD
	 *
	 * nh́CsetErrorHandler() ŃZbgD
	 *
	 * @param file __FILE__ 
	 * @param line __LINE__ 
	 * @param G[bZ[W
	 * @see TJSystemInternal#setErrorHandler()
	 * @see TJSystemInternal#setOutputHandler()
	 */
	static void errorPanic(const char* file, int line,
                           const char* msg, int error = 0);

	/**
	 * s̓ʏ.
	 * ʏ OS ł, new ̎sł́Cstd::bad_alloc O
	 * C̃\bhւ̌Ăяo͋NȂD
	 * new s 0 Ԃ^Cv̊ł́C̃\bhĂяo
	 * CA{[gD
	 * ̃\bh͒ڎgpCNX̃}NgpD
	 *
	 * nh́CsetErrorHandler() ŃZbgD
	 *
	 * @param file __FILE__ 
	 * @param line __LINE__ 
	 * @param G[bZ[W
	 * @see TJSystemInternal#setErrorHandler()
	 * @see TJSystemInternal#setOutputHandler()
	 */
	static void nomemPanic(const char* file, int line,
                           const char* msg);
	/**
	 * xbZ[Wo.
	 *
	 * yӁz͑sD
	 * ̃\bh͒ڎgpCNX̃}NgpD
	 * nh́CsetErrorHandler() ŃZbgD
	 *
	 * @param file __FILE__ 
	 * @param line __LINE__ 
	 * @param G[bZ[W
	 * @see TJSystemInternal#setErrorHandler()
	 * @see TJSystemInternal#setOutputHandler()
	 */
	static void printWarning(const char* file, int line,
                             const char* msg);

	/**
	 * O݃G[.
	 * yӁz͑sD
	 *
	 * ̃\bh͒ڎgpCNX̃}NgpD
	 *
	 * nh́CsetOutputHandler() ŃZbgD
	 *
	 * @param file __FILE__ 
	 * @param line __LINE__ 
	 * @param G[bZ[W
	 * @see TJSystemInternal#setErrorHandler()
	 * @see TJSystemInternal#setOutputHandler()
	 */
	static void logFailWarning(const char* file, int line,
                               const char* msg);

	/**
	 * G[nh̃Zbg.
	 *
	 * TJSystemInternal̃G[\bhĂяôbnhݒ肷.
	 * ŃZbgnhɐ͈ڂ邪Č ::abort() ̌ĂяoƂȂD
	 * ݒȂ΃bZ[Wo͌ abort() ̌ĂяoƂȂD
	 *
	 * @param handler G[nh
	 */
	static void setErrorHandler(void (*errorHandler)(void));

	/**
	 * ُ탁bZ[Wo͊֐̃Zbg.
	 *
	 * TJSystemInternal ̃G[\bhьx\o͗p
	 * C֐w肷D
	 * wȂ stderr  prinf o͂D
	 *
	 * @param output o̓nh
	 */
	static void setOutputHandler(void (*outputHandler)(const char*));

};

#define TJSystem_error(s)       TJSystemInternal::errorPanic(__FILE__, __LINE__, s)
#define TJSystem_invalid(s)     TJSystemInternal::invalidPanic(__FILE__, __LINE__, s)
#define TJSystem_warning(s)     TJSystemInternal::printWarning(__FILE__, __LINE__, s)
#define TJSystem_logFailure(s)  TJSystemInternal::logFailWarning(__FILE__, __LINE__, s)
#define TJSystem_Error(s, e)    TJSystemInternal::errorPanic(__FILE__, __LINE__, s, e)

#endif	/* !defined(TJSystemInternal_h) */
