/*-----------------------------------------------------------------------

      Copyright (c) 1998,1999 Eiwa System Management, Inc

                      All Rights Reserved

  This file contains proprietary source code and other proprietary
  material owned by Eiwa System Management, Inc. Published only in
  limited copyright sence.

------------------------------------------------------------------------*/
/*
 * $Id: TJThread.h,v 1.25 1999/07/28 06:02:43 hiranabe Exp $
 */
#if !defined(TJThread_h)
#define TJThread_h

#ifndef tjconfig_h
#include "tjconfig.h"
#endif

#ifndef TJMutex_h
#include "TJMutex.h"
#endif
#ifndef TJSync_h
#include "TJSync.h"
#endif

class TJRunnable;

/**
 * XbhJvZ邽߂̃NX.
 *
 * ThreadJack ł́C̃Xbhs삳邱ƂłD
 * ̃NX̓Xbh̍쐬EXbhɑ΂鑀JvZĂ.
 *
 * ThreadJack ł, XbhɂĎsvO̎@ɂ́C
 * ȉ 2D
 *
 * 1. TJThread TuNXCrun() I[o[ChD
 *
 * 2. TJRunnable TuNXCrun() I[o[ChD
 *
 * ꂼ̎s@́C̒ʂD
 * ̏ꍇ TJThread ܂͂̃TuNX̃IuWFNgKvł.
 *
 * \begin{verbatim}
 * (1) TJThread ̃TuNX̃IuWFNg쐬
 *
 *	class MyThread : public TJThread {
 *		  EEEE
 *	    public:
 *		MyThread(const char* name) : TJThread(name) { }
 *		  EEEE
 *		void run() {
 *			  EEEE  // override TJThread::run()
 *		}
 *	};
 *
 *	MyThread* thread = new MyThread("myname");
 *	thread->start();
 *  .........
 *  thread->join();  // KvłΏI҂킹
 *  // XbhIuWFNg delete Ă͂ȂȂ
 *
 * (2) TJRunnable ̎NX̃IuWFNgɂ
 *     TJThread IuWFNg쐬
 *
 *	class MyRunnable : public TJRunnable {
 *		  EEEE
 *	    public:
 *		  EEEE
 *		void run() {
 *			  EEEE  // implement TJRunnable::run()
 *		}
 *	};
 *
 *	MyRunnable* runnable = new MyRunnable;
 *	TJThread* thread = new TJThread(runnable, "myname");
 *	thread->start();
 *  .........
 *  thread->join();  // KvłΏI҂킹
 *  // XbhIuWFNg delete Ă͂ȂȂ
 *
 * \end{verbatim}
 *
 * (2)̎gp@́C1 TJRunnable IuWFNg𕡐 TJThread IuWFNg
 * ŋpłCƂ_D
 *
 * TJThread  java.lang.Thread ɎĂ邪 java Ƃ̓Ǘ@
 * قȂ邽߃XbhIuWFNg̍쐬ƏɎ̒ӂKvɂȂ.
 *
 * \begin{verbatim}
 *   XbhIuWFNg͕K new Zqɂq[v̈Ɋmۂ邱.
 *   XbhIuWFNg̓AvP[V delete Ȃ.
 * \end{verbatim}
 *
 * XbhVɕʂ̃Xbh𐶐ꍇC
 * ̃XbheXbhCꂽXbhqXbhƌĂԁD
 *
 * [Xbh̏ԂƃVXȅI]
 *
 * ANSI/ISO C++ ɂK肳 int main() ƂGg|Cg
 * ɍŏɓXbh, Ɂumain XbhvƌĂсCAvP[V
 *  TJThread NX̃CX^XƂĐXbhƕKvɉ
 * ʂ邱ƂD
 *
 * main XbhȊÕXbhł́CXbh̎svO
 * TJThread  TJRunnable  run() \bh̎Ƃĕ\D
 *
 * Xbh run() s̎C̃Xbh alive łƂD
 * run() 畜A邩C܂͖I TJThread::exit(int) т
 *  run() ͏ICalive Ԃ alive ԂւƑJڂD
 * Xbh̏IR[h́Crun() 玩RɕAꍇ0 ƂȂC
 * TJThread::exit(int) Ăяoꍇ͈IR[hƂȂD
 * ̏IR[h͑̃Xbh TJThread::join Ŏ󂯎邱ƂłD
 *
 * main XbhCTJThread::exit(int) ĂяoƂłD̏ꍇ
 * main Xbh alive ԂƂȂD
 *
 * ThreadJack ɉVXe(vZX)̏ÍĈǂꂩN
 * łD
 *
 * \begin{verbatim}
 *
 *   1. main Xbh main ̕A(return)D
 *     (TJThread::exit()Ăяo͕AƌȂȂ)
 *   2. Xbh(main ȊOł悢)̃VXeI(vZXI)
 *      NĂяo(ANSI/ISO C++ ł ::exit()  ::abort())
 *      ĂяoD
 *   3. SXbh alive ƂȂD
 *
 * \end{verbatim}
 *
 * ܂CThreadJack ł vZX̃Rs[sVXe
 * (UNIX  fork, Win32  CreateProcess)ɑ΂Ă͖̓`łD
 * (̊gڂƂ)
 *
 * [vCIeB]
 *
 * ׂẴXbh̓vCIeBDʂ, vCIeB̍
 * Xbh̓vCIeB̒ႢXbhɗD悵ĎsD
 * CvCIeBXPW[Oɗ^鐳mȉe
 * VXeˑł. 
 *
 * vCIeB̐l Java ƓdlƂ.vCIeB
 * ̃Xbh𐶐Xbhp setPriority() ɂ
 * ύXł.
 *
 * vCIeB́CXbh̐eq֌W̒ŌpDȂ킿C
 * VɐꂽXbh̃vCIeB̏l͐eXbh
 * vCIeBƓlłD
 *
 * [҂킹]
 *
 * XbhIuWFNgɑ΂join()̌ĂяoɂāC̃Xbh
 * ̏I҂킹邱ƂłD
 * ̐҂킹(joinability)ƂD
 * ,쐬Xbh̏IɊ֐SȂꍇCӎIɑ҂킹
 * ȗ邱Ƃ\łD
 *
 * \begin{verbatim}
 *   (a) 쐬Xbh̏IɊ֐Sꍇ
 *         MyThread* t = new MyThread("myname");
 *         t->start();  // joinable ȃXbh
 *           EEE
 *         int exitcode = t->join();
 *
 *   (b) 쐬Xbh̏IɊ֐SȂꍇ
 *         FreeThread* t = new FreeThread("myname");
 *         t->setJoinable(false); //  joinable ȃXbh
 *         t->start();
 *         // ȍ~Ct ̎sԂ͂̃Xbh؂藣D
 *         // [x] Ȍ *t ̃ANZX͈ʂɊ댯
 * \end{verbatim}
 *
 *  (a) ł͍쐬ꂽXbhIƂ join() A߂l
 * exit() ̈Ԃ. ɑ΂ (b) ł͍쐬ꂽXbhƂ̊ւ
 * 荇͈؂Ȃ. 쐬Xbh̏IԂĨ^C~OmKv
 * Ȃꍇɂ͂̕@͓s悢.Cjoinable ȃXbh͕K
 * join KvCt  joinable ȃXbh͌
 * join Ă͂ȂD
 *
 * VK쐬ꂽXbh̑҂킹͕K joinable ł, ҂킹
 * ͎qXbhɌp邱Ƃ͂Ȃ. 
 * setJoinable(false) ̑󂯂Xbh joinable ƂȂD
 *  joinable Xbh join() ꍇ͕̓sł. joinable 
 * ǂ setJoinable(bool) ɂύX\ł邪 main Xbh͕ύX
 * ł, K joinable łD
 *
 * ҂킹́Cjava.lang.Thread   Deamon Ƃ͖֌W̑ł邱
 * ɒӁD
 *
 * [̑]
 *
 * Xbh͖ODO͕KSXbhʂĈӂł͂ȂD
 * Ow肹ɐXbhɂ́CKȖOt^D
 *
 * java.lang.Thread  java.lang.Runnable  implements Ă邪, 
 * ThreadJack ł͂Q̃NXTJThread  TJRunnable ɂ͌p֌W
 * ĂȂ.
 *
 * TJThread ̃TuNXꍇ,̃NX̃fXgN^ protected 
 * 邱Ƃ𐄏. ɂCXbhϐƂĐC
 * delete 𒼐ڌĂяoƂoORpCɔłD
 *
 * JgXbhȊÕXbhI@\(LZ)
 * 񋟂Ȃ. 񋟂ƃvO}̓LZ̕یȂ
 * ΂ȂȂȂ. java.lang.Thread  suspend, stop, resume ͒񋟂ȂD
 *
 * XbhNX̃IuWFNgꍇC this IuWFNgɑ΂
 * ƃJgXbhɑ΂鑀̍N₷̂ŒӂKvłD
 * ̃NX̎ public \bh͈ȉ̂悤ɕނ.
 *
 * \begin{verbatim}
 * [A] CX^X\bh -- this IuWFNgɑ΂鑀
 *       void setPriority(int)
 *       int getPriority()
 *       void setJoinable(bool)
 *       bool isJoinable()
 *       bool isAlive()
 *       void setName(const char*)
 *       const char* getName()
 *       TJThread::ID getThreadID()
 * [B] NX\bh -- NXŜ̑
 *       TJThread* getThread(TJThread::ID)
 *       int activeCount()
 * [C] JgXbhɑ΂鑀
 *       void exit(int)
 *       void sleep(long)
 *       void yield()
 *       TJThread::ID currentThreadID()
 *       TJThread* currentThread()
 *       const char* currentThreadName()
 * [D] eXbh̗ł̎qXbhɑ΂鑀
 *       TJThread( ... )
 *       void start()
 *       int join()
 *       int join(long)
 * [E] ʏ̓[UڌĂяoƂ̖
 *       void run()
 * \end{verbatim}
 *
 * ɒӂׂ_ [C] ̃JgXbhɑ΂鑀ł. 
 * ׂ static ł邽ߌ`Iɂ̓NX\bhł邪JgXbh
 * Ƃ̃Xbhɑ΂鑀ł.
 *
 * Xbh̎ʏƂăXbhʎq(ID)ƃXbhIuWFNgւ
 * |C^l. O҂͌IɎł邪C҂͈̂ʂ
 * IȃNXbNKvƂ邽, łD
 * ăXbh̎ʂ̂ݕKvȂXbhʎqgׂł.
 *
 * @author Susumu TOKUI
 * @date 1998,6/20
 */
class TJThread {

	friend class TJThreadTester;

public:
	/**
	 * Xbhʎq̌^.
	 */
	typedef void* ID;

	/**
	 * XbhʎqƂ͂Ȃ蓾Ȃ萔.
	 */
	static const ID None;

	/**
	 * join() ̗OIȖ߂l.
	 *
	 * Ӗ --  joinable ȃXbh join() 悤Ƃ.
	 * JOINABLE ł͂ȂXbh join() ꍇ͕̓sł.
	 * ^C~Oɂ\܂ʂꂽꍇ͂̒l߂.
	 * ̒l͕֋X̂̂łCAvP[V͂̒lg
	 * R[hĂ͂ȂȂD
	 * ĺCINT_MAX
	 */
	static const int JOINDETACHED;

	/**
	 * join() ̗OIȖ߂l.
	 *
	 * Ӗ -- ^CAEglw join() Ń^CAEg.
	 * ĺCINT_MAX-1
	 */
	static const int JOINTIMEOUT;

	/**
	 * XbhDx̍ŏl.
	 */
	static const int MIN_PRIORITY;

	/**
	 * XbhDx̍ől.
	 */
	static const int MAX_PRIORITY;

	/**
	 * Xbh̃ftHgX^bNTCY(16kB).
	 */
	static const unsigned DEFSTACKSIZE;

protected:
	/**
	 * Xbh̎
	 */
	enum Kind { MAIN, FREE, JOINABLE };

private:
	/*
	 * XbhʎqXbhIuWFNgւ̍ϊpNX.
	 * ̕ϊ̓JgXbh̑ȂǂŕKvɂȂpɂɎg
	 * \. , Xbh̐EłƂ̋h߂
	 * NXbNKvɂȂϊȂ΂ȂȂ.
	 */
	class Assoc {
		friend class TJThread;
		friend class TJThreadTester;
    private:
		struct Pair {
			ID key;
			TJThread* value;
		};
		Pair* pointer;
		int psize;
		int count;
    public:
		Assoc(int inisize = 16);
		virtual ~Assoc();
		void put(ID key, TJThread* value);
		void remove(ID key);
		TJThread* get(ID key) const;
		TJThread* exchange(ID key, TJThread* newthread);
    private:
		int getIndex(ID key) const;
	};

	friend class Assoc;

	/*
	 * NXƂ̑샍bN ---- threadTable, ... p
	 */
	static TJMutex* classLock;	// ######## class lock ########

	/*
	 * XbhʎqXbhIuWFNgւ̍ϊpe[u
	 */
	static Assoc* threadTable;	// lock: classLock

	/*
	 * main XbhIuWFNg
	 */
	static TJThread* mainThread;	// lock: classLock

	static bool mainPurged;		// lock: classLock

	/*
	 * XbhȗɃj[NȖOt邽߂̃JE^
	 */
	static unsigned serialno;	// lock: classLock

	/*
	 * CX^XƂ̑샍bN
	 */
	mutable TJMutex threadMutex;	// ######## instance lock ########

	/*
	 * XbhIR[h (exit() ̈)
	 */
	int exitcode;		// lock: threadMutex

	/*
	 * join() ĂяoXbh
	 */
	TJThread* joinptr;	// lock: threadMutex

	/*
	 * exit()  join() ̓pϐ
	 */
	TJSync joinSync;	// lock: threadMutex

	/*
	 * XbhL[ƂCӂ̃[Uf[^
	 */
	void* anydata;		// lock: threadMutex

	/*
	 * Xbh
	 */
	char* name;		// lock: threadMutex

	/*
	 * Xbhʎq
	 *   VXẽXbh@\ďoŎg.
	 */
	ID threadID;

	/*
	 * Xbh̎ (MAIN, FREE, JOINABLE)
	 */
	Kind kind;		// lock: threadMutex

	/*
	 * eXbh
	 */
	TJThread* parent;

	/*
	 * TJRunnable ̎NX̃IuWFNg.
	 *   w肳Ă΂ run() Xbh{̂ƂȂ. łȂ
	 *   TJThread ̃TuNX run() Xbh{̂ƂȂ.
	 */
	TJRunnable* target;

	/*
	 * \bh run() ̒sȂ true
	 */
	bool running;		// lock: threadMutex

private:
	// Don't use.
	TJThread(const TJThread&);
	TJThread& operator=(const TJThread&);

private:
	/*
	 * main Xbh쐬.
	 */
	TJThread(Kind kind, ID tid);

public:
	/**
	 * TJThread IuWFNg쐬.
	 *
	 * @param stacksize X^bNTCY
	 */
	TJThread(unsigned stacksize = DEFSTACKSIZE);

	/**
	 * TJThread IuWFNg쐬.
	 *
	 * @param name  Xbh
	 * @param stacksize X^bNTCY
	 */
	TJThread(const char* name, unsigned stacksize = DEFSTACKSIZE);

	/**
	 * TJThread IuWFNg쐬.
	 *
	 * @param target  TJRunnable ̎NX̃IuWFNg
	 * @param stacksize X^bNTCY
	 */
	TJThread(TJRunnable* target, unsigned stacksize = DEFSTACKSIZE);

	/**
	 * TJThread IuWFNg쐬.
	 *
	 * @param target  TJRunnable ̎NX̃IuWFNg
	 * @param name  Xbh
	 * @param stacksize X^bNTCY
	 */
	TJThread(TJRunnable* target, const char* name,
             unsigned stacksize = DEFSTACKSIZE);

protected:
	/**
	 * TJThread IuWFNg.
	 *
	 * TJThread ̃TuNXłfXgN^ protected ɂ邱
	 * 𐄏D(XbhIuWFNg̃X^bNɊmۂ,
	 * delete Ăяő֎~)
	 *
	 * @see TJThread#join()
	 */
	virtual ~TJThread();

public:
	/**
	 * Xbh̃vCIeBݒ肷.
	 * Xbh̃vCIeB Java Ɠdl̗p.
	 * @param pri  Dx
	 */
	void setPriority(int pri);

	/**
	 * Xbh̃vCIeB擾.
	 * Xbh̃vCIeB Java Ɠdl̗p.
	 *
	 * @return vCIeB
	 */
	int getPriority() const;

	/**
	 * Joinable Xbh̏Ԃɐݒ肷.
	 */
	virtual void setJoinable(bool on);

	/**
	 * Joinable XbhȂ true Ԃ.
	 */
	virtual bool isJoinable() const;

	/**
	 * Xbh̎sJn.
	 */
	virtual void start();

	//virtual void stop();	// ̋@\͈Ӑ}IɗpӂȂ.

	/**
	 * Xbh{.
	 *
	 * ̃\bh̓CuĂяoXbh̃Gg|Cg
	 * , [UĂяoƂ͖Ӗł.
	 */
	virtual void run();

	/**
	 * XbhI҂킹.
	 *
	 * TJThread::exit ɂĕԂR[h󂯎邱ƂłD
	 * joinable ł͂ȂXbhɑ΂ join() sꍇ̓
	 * ͕sł. 
	 *
	 * @return XbhIR[h
	 * @see TJThread#exit()
	 */
	int join();

	/**
	 * ^CAEgw肵ăXbhI҂킹.
	 *
	 * TJThread::exit ɂĕԂR[h󂯎邱ƂłD
	 * @param milliseconds ~b
	 * @return XbhIR[h
	 *         TJThread::JOINTIMEOUT   ^CAEg
	 * @see TJThread#exit()
	 */
	int join(long milliseconds);

	/**
	 * JgXbhI.
	 *
	 * @param code XbhIR[h
	 * @see TJThread#join()
	 *
	 * XbhIR[hƂ
	 *     TJThread::JOINDETACHED, TJThread::JOINTIMEOUT
	 * ͗\񂳂Ă̂ŎgȂ.
	 */
	static void exit(int code);

	/**
	 * JgXbhw莞ԋx~.
	 *
	 * @param milliseconds ~b
	 */
	static void sleep(long milliseconds);

	/**
	 * JgXbĥbotꎞIɕ.
	 * ꎞIɎs𑼂̃XbhɏD
	 */
	static void yield();

	/**
	 * Xbhݒ肷.
	 *
	 * XbḧӐ͂̃\bhł͕ۏ؂Ȃ.
	 * @param name Xbh
	 */
	void setName(const char* name);

	/**
	 * XbhԂ.
	 *
	 * @return Xbh
	 */
	const char* getName() const;

	/**
	 * run() ̒sȂ true Ԃ.
	 *
	 * @return run()sȂ true
	 */
	bool isAlive() const;

	/**
	 * XbhԂ.
	 *
	 * @return Xbh
	 */
	static int activeCount();

	/**
	 * XbhʎqԂ.
	 */
	virtual ID getThreadID() const;

	/**
	 * XbhʎqXbhIuWFNg̃|C^𓾂.
	 * @param tid  Xbhʎq
	 */
	static TJThread* getThread(ID tid);

	/**
	 * JgXbh̃XbhʎqԂ.
	 */
	static ID currentThreadID();

	/**
	 * JgXbhIuWFNg̃|C^Ԃ.
	 */
	static TJThread* currentThread();

	/**
	 * JgXbh̖OԂ.
	 */
	static const char* currentThreadName();
#define TJThreadName()  TJThread::currentThreadName()

	/**
	 * AvP[Vf[^XbhɋL.
	 *
	 * ̃f[^̓XbhɕێłD
	 * ʏ̓X^bN΃XbhƂ̏Lł邪X^bN
	 * ̓\bh畜AƏł.
	 * XbhƂ, \bh畜AĂۑf[^Ǘ
	 * ꍇɂ̋@\g.
	 * Ǘf[^̎ɂĂ̓AvP[V̐ӔCł.
	 */
	void  putData(void* anydata);

	/**
	 * XbhƂ̏ԋp.
	 */
	void* getData() const;

protected:
	/*
	 * RXgN^̃X^bNTCYɂ̒l^ƃIuWFNg
	 * ̂ݎsXbh쐬Ȃ.
	 */
	static const unsigned NOTHREAD;

	/*
	 * Xbh̍쐬
	 * TuNXŃXbh쐬sꍇ̓RXgN^̃X^bN
	 * TCYɂ NOTHREAD ^Ẵ\bhĂяo.
	 */
	void createThread(unsigned stacksize, void* info);

	/*
	 * VXeˑ̃Xbh쐬
	 */
	virtual int create(void (*entrypoint)(void*), void* arg,
			unsigned stacksize, void* info, ID* ptid);

	/*
	 * JgXbh̃IuWFNgTuNX̃IuWFNgɕύX.
	 */
	static void exchange(TJThread* newthread);

private:
	/*
	 * 
	 */
	static void init();

	/*
	 * XbhIuWFNg̏
	 */
	void construct(const char* name, TJThread* parent, ID curtid);

	/*
	 * Xbh̍쐬
	 */
	void newContext(unsigned stacksize, void* info);

	/*
	 * IȓRXgN^
	 *
	 * XbhIuWFNg̏Xbh쐬.
	 * @param name Xbh
	 * @param stacksize X^bNTCY
	 */
	void add(const char* name, unsigned stacksize);

	/*
	 * IȓfXgN^
	 */
	void remove();
};


#endif	/* !defined(TJThread_h) */
