/*-----------------------------------------------------------------------

      Copyright (c) 1998,1999 Eiwa System Management, Inc

                      All Rights Reserved

  This file contains proprietary source code and other proprietary
  material owned by Eiwa System Management, Inc. Published only in
  limited copyright sence.

------------------------------------------------------------------------*/
/*
 * $Id: TJThreadTester.cc,v 1.7 1999/07/28 06:02:44 hiranabe Exp $
 */
#include "TJThreadTester.h"
#include <string>


TJThreadTester::TJThreadTester() : thread(TJThread::currentThread()) {
}

TJThreadTester::TJThreadTester(const TJThread* thr) : thread(thr) {
}

TJThreadTester::~TJThreadTester() {
}

/* ---------------------------------------------------------------------- */

void TJThreadTester::lock() {
	thread->threadMutex.lock();
	TJThread::classLock->lock();
}

void TJThreadTester::unlock() {
	TJThread::classLock->unlock();
	thread->threadMutex.unlock();
}

/* ---------------------------------------------------------------------- */

int TJThreadTester::enumerate(vector<TJThread*>& v) {
	int count = TJThread::threadTable->count;
	for (int n = 0; n < count; n++)
		v.push_back(TJThread::threadTable->pointer[n].value);
	return count;
}

/* ---------------------------------------------------------------------- */

TJThread::ID TJThreadTester::getThreadID() const {
	return thread->threadID;
}

const char* TJThreadTester::getName() const {
	return thread->name;
}

TJThreadTester::Kind TJThreadTester::getKind() const {
	return Kind(thread->kind);
}

bool TJThreadTester::getRunning() const {
	return thread->running;
}

int TJThreadTester::getExitcode() const {
	return thread->exitcode;
}

TJThread* TJThreadTester::getJoinptr() const {
	return thread->joinptr;
}

void* TJThreadTester::getAnydata() const {
	return thread->anydata;
}

TJThread* TJThreadTester::getParent() const {
	return thread->parent;
}

TJRunnable* TJThreadTester::getTarget() const {
	return thread->target;
}

TJThread* TJThreadTester::getMainThread() const {
	return thread->mainThread;
}

bool TJThreadTester::getMainPurged() const {
	return thread->mainPurged;
}

unsigned TJThreadTester::getSerialno() const {
	return thread->serialno;
}

/* ---------------------------------------------------------------------- */

ostream& TJThreadTester::print(ostream& o) const {
	string skind = (thread->kind == TJThread::MAIN)? "MAIN" :
		((thread->kind == TJThread::FREE)? "FREE" : "JOINABLE");
	string srunning = thread->running? "true" : "false";
	string smpurged = thread->mainPurged? "true" : "false";

	o << " ID=" << thread->threadID;
	o << " name=" << thread->name;
	o << " kind=" << skind;
	o << " running=" << srunning;
	o << endl;

	o << " mainThread=" << thread->mainThread;
	o << " mainPurged=" << smpurged;
	o << " serialno=" << thread->serialno;
	o << endl;

	o << " exitcode=" << thread->exitcode;
	o << " joinptr=" << thread->joinptr;
	o << endl;

	o << " parent=" << thread->parent;
	o << " target=" << thread->target;
	o << " anydata=" << thread->anydata;
	o << endl;
	return o;
}
