/*-----------------------------------------------------------------------

      Copyright (c) 1998,1999 Eiwa System Management, Inc

                      All Rights Reserved

  This file contains proprietary source code and other proprietary
  material owned by Eiwa System Management, Inc. Published only in
  limited copyright sence.

------------------------------------------------------------------------*/
/*
 * $Id: TJThreadTester.h,v 1.13 1999/11/17 04:10:14 hiranabe Exp $
 */
#if !defined(TJThreadTester_h)
#define TJThreadTester_h

#ifndef tjconfig_h
#include "tjconfig.h"
#endif

#include <vector>
#ifndef TJThread_h
#include "TJThread.h"
#endif
#ifndef tjstdnamespace_h
#include "tjstdnamespace.h"
#endif

#ifndef tjiostream_h
#include "tjiostream.h"
#endif

/**
 * Xbh̓Ԃ邽߂̃NX ---- eXgp.
 *
 * ̃NX̓eXgpłAvP[VvO̒Ŏg邱
 * ͑z肵ĂȂ.
 * Ώۂ TJThread ̂uԂ̃XibvVbgQƂł邾ƍl
 * 悢. ꉞXbh̍쐬E~Ώۂ̃Xbh
 * ԕύX֎~ lock() ͗pӂĂ邪fbhbNɂ͒ӂKvł
 * . ̃XbhΏۂ̃IuWFNgpɂɃANZXĂ󋵂
 * ͓ɒӂKvł.
 *
 * @author Susumu TOKUI, hiranabe
 * @date 1998,6/1
 * @date 1999,4/9
 */
class TJThreadTester {

private:
	const TJThread* thread;

public:
	enum Kind {
		MAIN = TJThread::MAIN,
		FREE = TJThread::FREE,
		JOINABLE = TJThread::JOINABLE
	};

	/**
	 * JgXbh TJThreadTester IuWFNg쐬.
	 */
	TJThreadTester();

	/**
	 * w肳ꂽXbh TJThreadTester IuWFNg쐬.
	 *
	 * @param thread Ώۂ̃Xbh̃|C^
	 */
	TJThreadTester(const TJThread* thread);

	/**
	 * TJThreadTester IuWFNg.
	 */
	virtual ~TJThreadTester();

	/**
	 * CX^XbNƓɃNXbNl.
	 *
	 * ԕύX̉\rꍇ̂ݎg.
	 */
	void lock();

	/**
	 * bNԂ𕜌.
	 *
	 * ԕύX̉\ꍇ
	 *     lock();
	 *     Ԃ̎Q;
	 *     unlock();
	 * Ƃ邱.
	 */
	void unlock();

	/**
	 * ׂẴXbhIuWFNg̃|C^ vector ɃZbg.
	 */
	static int enumerate(vector<TJThread*>& v);

	/**
	 * XbhʎqԂ.
	 *
	 * @return Xbhʎq
	 */
	TJThread::ID getThreadID() const;

	/**
	 * XbhԂ.
	 *
	 * @return Xbh
	 */
	const char* getName() const;

	/**
	 * Xbh(MAIN,FREE,JOINABLE)Ԃ.
	 *
	 * @return Xbh
	 */
	Kind getKind() const;

	/**
	 * XbhsǂԂ.
	 *
	 * @return sȂ true
	 */
	bool getRunning() const;

	/**
	 * XbhIR[hԂ.
	 *
	 * @return XbhIR[h
	 */
	int getExitcode() const;

	/**
	 * join() 悤ƂĂXbh̃|C^Ԃ.
	 *
	 * @return Xbh̃|C^
	 */
	TJThread* getJoinptr() const;

	/**
	 * XbhƂ̃[Uf[^Ԃ.
	 *
	 * @return [Uf[^̃AhX
	 */
	void* getAnydata() const;

	/**
	 * eXbh̃|C^Ԃ.
	 *
	 * @return eXbh̃|C^
	 */
	TJThread* getParent() const;

	/**
	 * TJRunnable ̎NX̃IuWFNgԂ.
	 *
	 * @return IuWFNg̃|C^
	 */
	TJRunnable* getTarget() const;

	/**
	 * main Xbh̃|C^Ԃ.
	 *
	 * @return main Xbh̃|C^
	 */
	TJThread* getMainThread() const;

	/**
	 * main XbhIǂԂ.
	 *
	 * @return IĂ true
	 */
	bool getMainPurged() const;

	/**
	 * j[NǗp̕ϐ̒lԂ.
	 *
	 * @return ϐ̒l
	 */
	unsigned getSerialno() const;

	/**
	 * TJThreadTester IuWFNg̓o͂.
	 *
	 * @param o o̓Xg[
	 * @return  o̓Xg[̎Q
	 */
	ostream& print(ostream& o) const;
};


/**
 * TJThreadTester IuWFNg̓o͂.
 *
 * @param o o̓Xg[
 * @param tester  o͑Ώۂ TJThreadTester
 * @return  o̓Xg[̎Q
 */
inline ostream& operator<<(ostream& o, const TJThreadTester& tester) {
	return tester.print(o);
}


#endif	/* !defined(TJThreadTester_h) */
