/*-----------------------------------------------------------------------

      Copyright (c) 1998,1999 Eiwa System Management, Inc

                      All Rights Reserved

  This file contains proprietary source code and other proprietary
  material owned by Eiwa System Management, Inc. Published only in
  limited copyright sence.

------------------------------------------------------------------------*/
/*
 * $Id: TJTransaction.h,v 1.8 1999/07/28 06:02:48 hiranabe Exp $
 */
#if !defined(TJTransaction_h)
#define TJTransaction_h

#ifndef tjconfig_h
#include "tjconfig.h"
#endif

#ifndef TJRWLock_h
#include "TJRWLock.h"
#endif

/**
 * Read/Write Lock(LErbN)̊JnƏIgUNV.
 *
 * LSɍXVEQƂ邽߂̃bN@\ TJRWLock ̊Jn
 * ICRXgN^ƃfXgN^ň.
 * ,bN擾͖ɑ҂[ĥ݃T|[g.
 *
 * RXgN^Ŏw胂[h̃bNlfXgN^ŉ.
 * XR[vEo鎞ɎIɃbNꍇɕ֗ł.
 *
 * ɁCOCr return  unlock ̌Ăяoۏ؂ꍇ
 * ́C̃NXgpׂł.
 *
 * ȉɎgp. ֐̗ł邪CCӂ̃XR[vIŎ擾
 * bNƉۏ؂ł(for, while, if, {} ubN).
 *
 * \begin{verbatim}
 *
 *    void f(TJRWLock* lock) {
 *          // ֐擪ŃbNm
 *          TJTransaction tr(lock, TRWRLock::SHARED);
 *
 *
 *          if (....)
 *                return;  // łbNۏ.
 *
 *          int* BigArray = new int[1000];
 *          // rCOɂĊ֐𔲂ĂbN.
 *
 *
 *    } // ֐IŃbN
 *
 * \end{verbatim}
 *
 * @author Susumu TOKUI
 * @date 1998,6/1
 */
class TJTransaction {

private:
	TJRWLock *const rwlock;

public:
	/**
	 * QƂ܂͍XV[hŃbNl.
	 *
	 * TJRWLock̋@\̂^CAEgw trylock (NONBLOCK) 
	 * @\͏OĂ邱Ƃɒ.
	 *
	 * ŗ^ꂽ RWLock  lock .
	 *
	 * @param rwlock TJRWLockIuWFNg̃|C^
	 * @param mode   TJRWLock::SHARED:     Qƃ[h
	 *               TJRWLock::EXCLUSIVE:  XV[h
	 */
	TJTransaction(TJRWLock* rwlock, TJRWLock::LockMode mode);

	/**
	 * fXgN^(bN).
	 *
	 * RXgN^Ŏ擾 RWLock  unlock .
	 */
	virtual ~TJTransaction();
};


#endif	/* !defined(TJTransaction_h) */
