/*-----------------------------------------------------------------------

      Copyright (c) 1998,1999 Eiwa System Management, Inc

                      All Rights Reserved                         

  This file contains proprietary source code and other proprietary
  material owned by Eiwa System Management, Inc. Published only in
  limited copyright sence.

------------------------------------------------------------------------*/
/*
 * $Id: TJWSync.c,v 1.1 1999/05/21 07:20:42 tokui Exp $
 */
/**
 * Windows ł̃v~eBu[`
 *
 * Windows ł͔rƖ֌Wȓł邪ł UNIX Xbh
 * lɍ킹.
 * Ď̃C^tF[X
 *     extern void TJSyncWait(void* sync);
 *     extern void TJSyncWaitTimeout(void* sync, int milliseconds);
 * ͗pӂȂ.
 *
 * wait()  notify() sꍇ̖ɂ
 *
 *     lock
 *     while ( Lgp ) {        lock
 *         unlock                        L𑀍
 *         wait      signal
 *         lock                          unlock
 *     }
 *     L𑀍
 *     unlock
 *
 * UNIX ̏ꍇ cond_wait(&cond, &mutex)  unlock; wait; lock; Ag~bN
 * Ɏs.  unlock  wait ܂ł̊Ԃ signal ĂCx
 * g邱Ƃ͂Ȃ.
 *
 * Windows  cond_wait() ɑ@\邽߂Ɏg API Ƃ
 *   (1) Semaphore
 *   (2) Event
 *     (2-1) Auto Reset Event
 *     (2-2) Manual Reset Event
 * .
 * Semaphore ̓Cxghɂ͓KĂ邪 notifyAll() ̎.
 * Auto Reset Event  notifyAll() ̎ɖ肪.
 *
 *     notifyAll()  notify() ̌JԂŎłȋC邪{
 *     Ag~bNɎsׂ邱Ƃɂ肪N.
 *
 * , Ag~bNɂׂĂ̑ҋ@̃XbhfBɂł Manual
 * Reset Event IԂƂɂ.
 *
 * Event VOiԂɂ֐ PulseEvent()  SetEvent() ł.
 * PulseEvent() ̓Cxgɂĉivɑ҂Ă܂댯lȂ
 * ΂ȂȂ. SetEvent() ͋tɑ҂ׂɌVOiԂ̂߂ɑ҂
 * Ƃ肪N₷.
 *
 * _ƂĎ̕j cond_wait() @\.
 *
 * Xbh Manual Reset Event őҋ@.  notifyAll()
 *   ̎͗eՂł.
 * ҋ@Xbh͎ʎq Event Ƃ̃Xgɒǉ.
 * }Xbh notify() Ȃ΂P notifyAll() Ȃ΂ׂĂ
 *   ̃Xg폜ׂẴXbhfBɂ.
 * ҋ@Xbh͎̎ʎq̃Xg폜܂Ń[v
 *   ҋ@𑱂.
 *
 * vɂׂẴXbhNĖ{ notify ꂽǂŌ
 * jł UNIX J[l̃XPW[Ăяo wakeup() Ɠl
 * ł.
 *
 * ҋ@Xbh̎葱͎̂Ƃ.
 *
 *      TJMutexLock(plist->lock);           // Xgی삷郍bNl
 *
 *      // XgɎ̃Xbhʎqǉ
 *      append(plist, TJThreadSelf());
 *
 *      // ̃XbhʎqXg폜܂Ń[v
 *      while (!isnotified(plist, TJThreadSelf())) {
 *
 *              // SetEvent() ̋tłVOiԂɖ߂
 *              ResetEvent(plist->event);
 *
 *              TJMutexUnlock(plist->lock); // Xgی삷郍bN
 *
 *              TJMutexUnlock(mutex);       // ʂŎgbN
 *
 *              // SetEvent() ܂ŃubN
 *              WaitForSingleObject(plist->event, milliseconds);
 *
 *              TJMutexLock(mutex);         // ʂŎgbN𕜌
 *
 *              TJMutexLock(plist->lock);   // Xgی삷郍bN𕜌
 *      }
 *
 *      TJMutexUnlock(plist->lock);         // Xgی삷郍bN
 *
 * }Xbh̎葱͎̂Ƃ.
 *
 *      TJMutexLock(plist->lock);           // Xgی삷郍bNl
 *
 *      // XgP܂ׂ͂ẴXbh폜
 *      notify(plist, all);
 *
 *      TJMutexUnlock(plist->lock);         // Xgی삷郍bN
 *
 *      // Manual Reset Event ̎dlɂ肷ׂẴXbh̃ubN
 *      SetEvent(plist->event);
 */

#include <windows.h>
#include <limits.h>
#include <errno.h>
#include "TJPrimitive.h"


/**
 * Xbhʎq̃XĝPvf.
 */
typedef struct threadid {
	struct threadid* next;
	struct threadid* prev;
	void* tid;             /* thread ID */
} threadid_t;

/**
 * Xbhʎq̃Xg.
 *
 * ܂ notify ĂȂXbh̎ʎq̓o head ̃Xg
 * ݂.  notify ƃXg폜.
 * ʂɂ͓IuWFNgƂĂ̍\̂̃|C^Ԃ.
 */
typedef struct {
	HANDLE event;          /* Manual Reset Event */
	void* lock;            /* Xgی삷邽߂̃bN */
	threadid_t  head;      /* Xgwb_ */
	threadid_t* tail;      /* Xg̍Ō̗vfw|C^ */
	threadid_t* freelist;  /* gpԂ̗vf̃Xg */
} synclist_t;

#define BROADCAST 1  /* notifyAll() */
#define SIGNAL    0  /* notify() */


/**
 * V threadid_t \̂Ԃ.
 */
static threadid_t* newcell(synclist_t* plist) {
	threadid_t* ptid = plist->freelist;
	if (ptid == (threadid_t*)0)
		ptid = (threadid_t*)malloc(sizeof(threadid_t));
	else
		plist->freelist = ptid->next;
	if (ptid != (threadid_t*)0) {
		ptid->next = ptid->prev = 0;
		ptid->tid = 0;
	}
	return ptid;
}

/**
 * svƂȂ threadid_t \̂ԋp.
 */
static void freecell(synclist_t* plist, threadid_t* ptid) {
	ptid->next = plist->freelist;
	plist->freelist = ptid;
}

/**
 * Xbhʎq(threadid_t)Xg̍ŌɃN.
 */
static void link(synclist_t* plist, threadid_t* ptid) {
	plist->tail->next = ptid;
	ptid->prev = plist->tail;
	ptid->next = 0;
	plist->tail = ptid;
}

/**
 * w̃Xbhʎq(threadid_t)Xg폜.
 */
static void unlink(synclist_t* plist, threadid_t* ptid) {
	if (plist->tail == ptid)
		plist->tail = ptid->prev;
	if (ptid->prev != 0)
		ptid->prev->next = ptid->next;
	if (ptid->next != 0)
		ptid->next->prev = ptid->prev;
}

/**
 * XgTw̃Xbhʎq\ threadid_t Ԃ.
 */
static threadid_t* find(synclist_t* plist, void* tid) {
	threadid_t* ptid;
	for (ptid = plist->head.next; ptid != 0; ptid = ptid->next)
		if (ptid->tid == tid)
			return ptid;	/* found */
	return (threadid_t*)0;		/* not found */
}

/**
 * \ synclist_t ̗̈mۂƏ.
 */
static int createInfo(synclist_t** pp) {
	synclist_t* plist;
	threadid_t* ptid;

	if ((plist = (synclist_t*)malloc(sizeof(synclist_t))) == 0)
		return ENOMEM;

	plist->lock = 0;
	plist->event = NULL;

	plist->head.next = plist->head.prev = 0;
	plist->head.tid = 0;

	plist->tail = &plist->head;
	plist->freelist = 0;

	if ((ptid = newcell(plist)) == 0) {
		free((void*)plist);
		return ENOMEM;
	}
	freecell(plist, ptid);

	*pp = plist;
	return 0;
}

/**
 * \ synclist_t ̗̈.
 */
static void cleanInfo(synclist_t* plist) {
	threadid_t* ptid;
	while ((ptid = plist->head.next) != 0) {
		unlink(plist, ptid);
		free((void*)ptid);
	}
	while ((ptid = plist->freelist) != 0) {
		plist->freelist = ptid->next;
		free((void*)ptid);
	}
	free((void*)plist);
}

/**
 * w̃XbhʎqXgɒǉ.
 *
 * ̏ wait ̎ɌĂяo.
 * XgیpbN(plist->lock)͊lԂł邱.
 */
static int append(synclist_t* plist, void* tid) {
	threadid_t* ptid = newcell(plist);
	if (ptid == (threadid_t*)0)
		return ENOMEM;
	ptid->tid = tid;
	link(plist, ptid);
	return 0;
}

/**
 * P܂ׂ͂ẴXbhʎqXg폜.
 *
 * ̏ notify ̎ɌĂяo.
 * XgیpbN(plist->lock)͊lԂł邱.
 */
static void notify(synclist_t* plist, int all) {
	threadid_t* ptid;
	if (!all) {
		if ((ptid = plist->head.next) != (threadid_t*)0) {
			unlink(plist, ptid);
			freecell(plist, ptid);
		}
	} else {
		while ((ptid = plist->head.next) != (threadid_t*)0) {
			unlink(plist, ptid);
			freecell(plist, ptid);
		}
	}
}

/**
 * w̃XbhʎqXg폜.
 *
 * ̏ notify ł͂Ȃ^CAEgɌĂяo.
 * XgیpbN(plist->lock)͊lԂł邱.
 */
static void remove(synclist_t* plist, void* tid) {
	threadid_t* ptid = find(plist, tid);
	if (ptid == (threadid_t*)0)
		return;
	unlink(plist, ptid);
	freecell(plist, ptid);
}

/**
 * notify ꂽǂ𒲂ׂ.
 *
 * w̃XbhʎqXgɑ݂Ă΂܂ notify ĂȂ.
 * XgیpbN(plist->lock)͊lԂł邱.
 */
static int isnotified(synclist_t* plist, void* tid) {
	return find(plist, tid) == (threadid_t*)0;
}

/* ------------------------------------------------------------------------- */

/**
 * pthread_cond_wait() ܂ pthread_cond_timedwait() ̕⏕@\.
 *
 * @return plus: error, minus: timeout, zero: notified
 */
static int block(HANDLE event, void* mutex, DWORD milliseconds) {
	int error, error2;
	DWORD wresult;

	error = TJMutexUnlock(mutex);
	if (error)
		return error;

	wresult = WaitForSingleObject(event, milliseconds);
	if (wresult != WAIT_OBJECT_0 && wresult != WAIT_TIMEOUT)
		error = GetLastError();

	error2 = TJMutexLock(mutex);

	if (wresult == WAIT_TIMEOUT)
		return -1;

	return (error > 0)? error : error2;
}

/**
 * pthread_cond_wait() ܂ pthread_cond_timedwait() ɑ@\.
 *
 * @return plus: error, minus: timeout, zero: notified
 */
static int waitEvent(synclist_t* plist, void* mutex, DWORD milliseconds) {
	void* tid;
	int error;

	tid = TJThreadSelf();

	error = TJMutexLock(plist->lock);
	if (error)
		return error;

	error = append(plist, tid);
	if (error) {
		(void)TJMutexUnlock(plist->lock);
		return error;
	}

	while (!isnotified(plist, tid)) {
		if (!ResetEvent(plist->event)) {	/* FALSE: error */
			(void)TJMutexUnlock(plist->lock);
			return GetLastError();
		}

		error = TJMutexUnlock(plist->lock);
		if (error)
			return error;

		error = block(plist->event, mutex, milliseconds);
		if (error) {
			if (error < 0) {
				/*
				 * timeout
				 */
				if (TJMutexLock(plist->lock) == 0) {
					remove(plist, tid);
					(void)TJMutexUnlock(plist->lock);
				}
			}
			return error;
		}

		error = TJMutexLock(plist->lock);
		if (error)
			return error;
	}

	return TJMutexUnlock(plist->lock);
}

/**
 * pthread_cond_signal() ܂ pthread_cond_broadcast() ɑ@\.
 */
static int postEvent(synclist_t* plist, int all) {
	int error;

	error = TJMutexLock(plist->lock);
	if (error)
		return error;

	notify(plist, all);

	error = TJMutexUnlock(plist->lock);

	if (!SetEvent(plist->event))	/* FALSE: error */
		return GetLastError();
	return error;
}

/*****************************************************************************
 *                 ֘Ãv~eBu
 *****************************************************************************/

/**
 * ϐ쐬.
 *
 * CreateEvent() ̑Q TRUE Ƃ Manual Reset Event ɂȂ.
 * ̍̓IuWFNg쐬ɂP(Auto Reset Event)VOi
 * ɂ邩ׂĂ(Manual Reset Event)VOiԂɂ邩߂Ȃ
 * ȂȂƂł.
 */
int TJSyncCreate(void** psync) {
	synclist_t* plist;
	void* lock;
	HANDLE event;
	int error;

	event = CreateEvent(NULL, TRUE, FALSE, NULL);
	if (event == NULL)
		return GetLastError();

	error = createInfo(&plist);
	if (error) {
		CloseHandle(event);
		return error;
	}

	error = TJMutexCreate(&lock);
	if (error) {
		CloseHandle(event);
		cleanInfo(plist);
		return error;
	}

	plist->event = event;
	plist->lock = lock;
	*psync = plist;
	return 0;
}

/**
 * ϐ폜.
 */
void TJSyncDelete(void* sync) {
	synclist_t* plist = (synclist_t*)sync;
	if (plist->event != NULL)
		CloseHandle(plist->event);
	if (plist->lock != 0)
		TJMutexDelete(plist->lock);
	cleanInfo(plist);
}

/**
 * ҂s.
 */
int TJSyncWait(void* sync, void* mutex) {
	return waitEvent((synclist_t*)sync, mutex, INFINITE);
}

/**
 * ҂s. (^CAEgt)
 *
 * @return plus: error, minus: timeout, 0: notified
 */
int TJSyncWaitTimeout(void* sync, void* mutex, int milliseconds) {
	return waitEvent((synclist_t*)sync, mutex, (DWORD)milliseconds);
}

/**
 * ҂̉ʒms.
 */
int TJSyncNotify(void* sync) {
	return postEvent((synclist_t*)sync, SIGNAL);
}

/**
 * ҂̉ʒms. (u[hLXg)
 */
int TJSyncNotifyAll(void* sync) {
	return postEvent((synclist_t*)sync, BROADCAST);
}
