/**
 *                 TJThread               CWinThread
 *                     ^                       ^
 *                     |                       |
 *                     |                       |
 *                 TJMFCThread  <>====<>  TJWinThread
 *                 ^         ^
 *                 |         |
 *                 |         |
 *       (WorkerThread) TJMFCGUIThread
 */

#include "TJWinThread.h"
#include "TJMFCThread.h"


/**
 * RXgN^.
 */
TJWinThread::TJWinThread(TJMFCThread* pMFCThread) : m_pMFCThread(pMFCThread) {
	/*
	 * CWinThread ̎폜It
	 */
	m_bAutoDelete = FALSE;
	m_pMainWnd = NULL;
}

/**
 * CWinThread ̃bZ[W[v
 *
 * CWinThread  Run()  virtual ł邽߃bZ[W[v̒ڂ̃Gg
 * ͂̃\bhɂȂ.
 * ł TJMFCThread::run() ĂяoĂ邽 TJMFCThread ŃbZ[W
 * [v㏑ł邱ƂɂȂ.
 * Ȃ, ftHg TJMFCThread::run()  CWinThread::Run() Ăяo.
 * ǂ̃\bh̃ftHg̓IWi CWinThread::Run() ł.
 */
int TJWinThread::Run() {
	ASSERT(m_pMFCThread);
	m_pMFCThread->run();
	return 0;
}

/**
 * ftHg TJMFCThread ̓Õ\bhɐU邱.
 */
BOOL TJWinThread::InitInstance() {
	ASSERT(m_pMFCThread);
	return m_pMFCThread->InitInstance();
}

int TJWinThread::ExitInstance() {
	ASSERT(m_pMFCThread);
	return m_pMFCThread->ExitInstance();
}

BOOL TJWinThread::OnIdle(LONG lCount) {
	ASSERT(m_pMFCThread);
	return m_pMFCThread->OnIdle(lCount);
}

BOOL TJWinThread::PreTranslateMessage(MSG* pMsg) {
	ASSERT(m_pMFCThread);
	return m_pMFCThread->PreTranslateMessage(pMsg);
}

BOOL TJWinThread::IsIdleMessage(MSG* pMsg) {
	ASSERT(m_pMFCThread);
	return m_pMFCThread->IsIdleMessage(pMsg);
}

LRESULT TJWinThread::ProcessWndProcException(CException* e, const MSG* pMsg) {
	ASSERT(m_pMFCThread);
	return m_pMFCThread->ProcessWndProcException(e, pMsg);
}

BOOL TJWinThread::ProcessMessageFilter(int code, LPMSG lpMsg) {
	ASSERT(m_pMFCThread);
	return m_pMFCThread->ProcessMessageFilter(code, lpMsg);
}

int TJWinThread::originalRun() {
	return CWinThread::Run();
}

BOOL TJWinThread::originalInitInstance() {
	return TRUE; /*CWinThread::InitInstance();*/
}

int TJWinThread::originalExitInstance() {
	return CWinThread::ExitInstance();
}

BOOL TJWinThread::originalOnIdle(LONG lCount) {
	return CWinThread::OnIdle(lCount);
}

BOOL TJWinThread::originalPreTranslateMessage(MSG* pMsg) {
	return CWinThread::PreTranslateMessage(pMsg);
}

BOOL TJWinThread::originalIsIdleMessage(MSG* pMsg) {
	return CWinThread::IsIdleMessage(pMsg);
}

LRESULT TJWinThread::originalProcessWndProcException(CException* e,
		const MSG* pMsg) {
	return CWinThread::ProcessWndProcException(e, pMsg);
}

BOOL TJWinThread::originalProcessMessageFilter(int code, LPMSG lpMsg) {
	return CWinThread::ProcessMessageFilter(code, lpMsg);
}
