/**
 * TJSyncObject gďI̓ƂvO.
 *
 *         TJThread
 *    
 *                  
 *     TJSyncObject      TJThread
 *        
 *      wait()              
 *                  Notifier
 *     notify() `        
 *        
 *                  
 *    
 *
 * ̃vO̍l PFProcessor ̊{IȘggł.
 * PFProcessor ɊւĎ̂Ƃ.
 *
 * C/S f̃Xbhz肵̗̓[v\.
 *
 * public synchronized void run() Ɠz.
 *   ܂Xbh̃R[h (protected, private \bh) ͌Ƃ
 *   bNԂŎs.
 *
 * OĂ΂ public \bh̓j^[Iy[VƂ.
 *
 * v҂bN. open region ͂Pӏ݂̂Ƃ.
 *   ܂ critical region ̋tŃbN݂̂ӎ.
 *
 * LXbhƂɊǗbNXbhƂɂP蓖Ă.
 *   bNpbVuIuWFNgɕUbŇʂǂ.
 *   run() ΃bN󋵂킩.
 *   Ӗł̓IuWFNgwɋts葱wł邪fbhbN
 *   ̋|.
 *
 * tւ̃Cxg`B TJSafeEventSouce gƂɂfbhbN
 *   ł.
 *
 * ProcessorCreator Ƃ̏I@\g΃XbhI̕GȖ
 *   JvZł.
 *
 * f
 *     wb_t@CƎt@C𕪂ׂł, ̓TvƂ
 *     Ŏ蔲܂. ^_^;)
 */

#include "tjiostream.h"
#include "tjmtsupp.h"

class Printer : public TJSyncObject {

  public:
	Printer() { }

	/**
	 * Wo͂Ȃ悤ɔrIɏo͂.
	 */
	void print(const char* msg) const {
		synchronized(this) {
			cout << TJThreadName() << ": " << msg << endl;
		}
	}
};

class Waiter : public TJThread, virtual public TJSyncObject {

  private:
	/**
	 * TJSemaphore ƈăCX^Xϐ signaled  notify() ꂽƂ
	 * LȂ notify() sƂ wait() ͉iɖڊo߂Ȃ.
	 */
	bool signaled;
	const Printer& pr;

  public:
	Waiter(const char* name, const Printer& p)
			: TJThread(name), TJSyncObject(), pr(p) {
		signaled = false;
	}

	/**
	 * Xbh{.
	 *     Iv܂Ŗ邾ƂȂƂӖȃXbh.
	 */
	void run() {
		pr.print("started");
		synchronized(this) {
			while (!signaled)
				wait();
		}
		pr.print("signaled --- bye ---");
	}

	/**
	 * Iv.
	 *     ̃\bh Notifier ̃ReLXgŎs.
	 */
	void signal() {
		synchronized(this) {
			signaled = true;
			notify();
		}
	}
};

class Notifier : public TJThread {

  private:	
	Waiter* waiter;
	const Printer& pr;

  public:
	Notifier(Waiter* waiter, const char* name, const Printer& p)
			: TJThread(name), pr(p) {
		this->waiter = waiter;
	}

	/**
	 * Xbh{.
	 *     Pbԋx Waiter XbhɏIvo.
	 */
	void run() {
		pr.print("started & sleep");
		TJThread::sleep(1000);
		waiter->signal();
		pr.print("--- bye ---");
	}
};

int main(int, char**) {
	Printer pr;
	Waiter* w = new Waiter("Waiter", pr);
	Notifier* n = new Notifier(w, "Notifier", pr);
	w->start();
	n->start();
	/*
	 * Xbh̏Iҋ@.
	 */
	w->join();
	n->join();
	return 0;
}
